package pwc.taxtech.atms.common;


import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;

import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

/**
 * author kevin
 * target ： Solve ThousandConvert
 * version 1.0
 */
public class ThousandConvert extends JsonSerializer<BigDecimal> {
    @Override
    public void serialize(BigDecimal value, JsonGenerator jgen, SerializerProvider arg2)
            throws IOException {
        NumberFormat integerInstance = NumberFormat.getIntegerInstance(Locale.getDefault());
        integerInstance.setMinimumFractionDigits(2);
        integerInstance.setRoundingMode(RoundingMode.HALF_UP);
        integerInstance.setGroupingUsed(true);
        jgen.writeString(integerInstance.format(value));
    }
}
