package pwc.taxtech.atms.constant.enums;

import java.util.HashMap;
import java.util.Map;

public class BackLogEnum {


    public enum AdminPermission {
        BACKLOG_DETAIL("10.001.001.001", "事项列表"),
        BACKLOG_GROUP("10.001.002.001", "事项组"),
        BACKLOG_CALENDAR("10.001.004.001", "事项日历"),
        BACKLOG_CASE("10.001.006.001", "企业/业务线病例");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        AdminPermission(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.AdminPermission permission : BackLogEnum.AdminPermission.values()) {
                MAPPING.put(permission.getCode(), permission.getName());
            }
        }
    }

    /**
     * 事项事实状态
     */
    public enum DetailStatus {
        UN_BEGIN("UN_BEGIN", "未开始"),
        BEGIN("BEGIN", "进行中"),
        UN_AUDIT("UN_AUDIT", "待审核"),
        REJECT("REJECT", "退回修正"),
        COMPLETED("COMPLETED", "已完成"),
        VOIDED("VOIDED", "已失效");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        DetailStatus(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.DetailStatus status : BackLogEnum.DetailStatus.values()) {
                MAPPING.put(status.getCode(), status.getName());
            }
        }
    }

    /**
     * 事项生成方式
     */
    public enum GenerateType {
        ONCE(1, "单次"),
        CYCLE(2, "周期");
        private Integer code;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        GenerateType(Integer code, String name) {
            this.code = code;
            this.name = name;
        }

        public Integer getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.GenerateType type : BackLogEnum.GenerateType.values()) {
                MAPPING.put(type.getCode(), type.getName());
            }
        }
    }

    /**
     * 事项生成方式
     */
    public enum AutoFlagType {
        YES(true, "是"),
        NO(false, "否");
        private Boolean code;
        private String name;
        public static final Map<Boolean, String> MAPPING = new HashMap<>();

        AutoFlagType(Boolean code, String name) {
            this.code = code;
            this.name = name;
        }

        public Boolean getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.AutoFlagType type : BackLogEnum.AutoFlagType.values()) {
                MAPPING.put(type.getCode(), type.getName());
            }
        }
    }

    public enum GroupCommonStatus {
        UN_COMPLETED("UN_COMPLETED", "创建中"),
        COMPLETED("COMPLETED", "创建完成"),
        VOIDED("VOIDED", "已失效");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        GroupCommonStatus(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.GroupCommonStatus status : BackLogEnum.GroupCommonStatus.values()) {
                MAPPING.put(status.getCode(), status.getName());
            }
        }
    }
    public enum ConfigCommonStatus {
        UN_COMPLETED("UN_COMPLETED", "创建中"),
        COMPLETED("COMPLETED", "创建完成"),
        VOIDED("VOIDED", "已失效");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        ConfigCommonStatus(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.ConfigCommonStatus status : BackLogEnum.ConfigCommonStatus.values()) {
                MAPPING.put(status.getCode(), status.getName());
            }
        }
    }

    public enum ConfigStatus {
        UN_COMPLETED("UN_COMPLETED", "创建中"),
        COMPLETED("COMPLETED", "创建完成"),
        VOIDED("VOIDED", "已失效");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        ConfigStatus(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.ConfigStatus status : BackLogEnum.ConfigStatus.values()) {
                MAPPING.put(status.getCode(), status.getName());
            }
        }
    }
    public enum UserType {
        CREATE_USER("CREATE_USER", "创建人"),
        DEAL_USER("DEAL_USER", "办事人"),
        AUDIT_USER("AUDIT_USER", "审核人");
        private String code;
        private String name;
        public static final Map<String, String> MAPPING = new HashMap<>();

        UserType(String code, String name) {
            this.code = code;
            this.name = name;
        }

        public String getCode() {
            return code;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.UserType status : BackLogEnum.UserType.values()) {
                MAPPING.put(status.getCode(), status.getName());
            }
        }
    }

    public enum BacklogDetailExportColumn {
        Column_1(0, "逾期标识"),
        Column_2(1, "事项ID"),
        Column_3(2, "分类"),
        Column_4(3, "子分类"),
        Column_5(4, "事项名称"),
        Column_6(5, "业务线"),
        Column_7(6, "公司名称"),
        Column_8(7, "起始时间（中国）"),
        Column_9(8, "截至时间（中国）"),
        Column_10(9, "起始时间（当地）"),
        Column_11(10, "截至时间（当地）"),
        Column_12(11, "时区"),
        Column_13(12, "税务代理"),
        Column_14(13, "涉及金额"),
        Column_15(14, "当前处理人员"),
        Column_16(15, "事项状态"),
        Column_17(16, "办事人"),
        Column_18(17, "审核人"),
        Column_19(18, "创建人"),
        Column_20(19, "生成方式"),
        Column_21(20, "事项组ID"),
        Column_22(21, "是否有附件"),
        Column_23(22, "事项描述"),
        Column_24(23, "备注"),
        ;
        private Integer index;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        BacklogDetailExportColumn(Integer index, String name) {
            this.index = index;
            this.name = name;
        }

        public Integer getIndex() {
            return index;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.BacklogDetailExportColumn column : BackLogEnum.BacklogDetailExportColumn.values()) {
                MAPPING.put(column.getIndex(), column.getName());
            }
        }
    }

    public enum BacklogConfigCommonExportColumn {
        Column_1(0, "分类"),
        Column_2(1, "子分类"),
        Column_3(2, "事项名称"),
        Column_4(3, "系统预设"),
        Column_5(4, "生成方式"),
        Column_6(5, "状态")
        ;
        private Integer index;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        BacklogConfigCommonExportColumn(Integer index, String name) {
            this.index = index;
            this.name = name;
        }

        public Integer getIndex() {
            return index;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.BacklogConfigCommonExportColumn column : BackLogEnum.BacklogConfigCommonExportColumn.values()) {
                MAPPING.put(column.getIndex(), column.getName());
            }
        }
    }

    public enum BacklogConfigExportColumn {
        Column_1(0, "事项ID"),
        Column_2(1, "分类"),
        Column_3(2, "子分类"),
        Column_4(3, "事项名称"),
        Column_5(4, "业务线"),
        Column_6(5, "公司名称"),
        Column_7(6, "起始时间（当地）"),
        Column_8(7, "截至时间（当地）"),
        Column_9(8, "时区"),
        Column_10(9, "事项状态"),
        Column_11(10, "办事人"),
        Column_12(11, "审核人"),
        Column_13(12, "创建人"),
        Column_14(13, "生成方式"),
        Column_15(14, "事项组ID"),
        Column_16(15, "是否有附件")
        ;
        private Integer index;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        BacklogConfigExportColumn(Integer index, String name) {
            this.index = index;
            this.name = name;
        }

        public Integer getIndex() {
            return index;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.BacklogConfigExportColumn column : BackLogEnum.BacklogConfigExportColumn.values()) {
                MAPPING.put(column.getIndex(), column.getName());
            }
        }
    }

    public enum BacklogGroupExportColumn {
        Column_1(0, "事项组ID"),
        Column_2(1, "事项组名称"),
        Column_3(2, "公司名称"),
        Column_4(3, "业务线"),
        Column_5(4, "时区"),
        Column_6(5, "事项组起始时间"),
        Column_7(6, "事项组截至时间"),
        Column_8(7, "生成方式"),
        Column_9(8, "创建人"),
        Column_10(9, "状态")
        ;
        private Integer index;
        private String name;
        public static final Map<Integer, String> MAPPING = new HashMap<>();

        BacklogGroupExportColumn(Integer index, String name) {
            this.index = index;
            this.name = name;
        }

        public Integer getIndex() {
            return index;
        }

        public String getName() {
            return name;
        }

        static {
            for (BackLogEnum.BacklogGroupExportColumn column : BackLogEnum.BacklogGroupExportColumn.values()) {
                MAPPING.put(column.getIndex(), column.getName());
            }
        }
    }
}
