package pwc.taxtech.atms.dto.backlogManage;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import pwc.taxtech.atms.common.util.PwCIdSerialize;
import pwc.taxtech.atms.dpo.BacklogDetailDto;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Objects;

public class BacklogCalendarViewResult implements Serializable {


    private static final long serialVersionUID = 3815322256703187932L;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long commonId;

    private String commonName;

    private Date startDate;

    private Date endDate;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long backlogTypeId;

    private String color;


    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }
    public Long getCommonId() {
        return commonId;
    }

    public void setCommonId(Long commonId) {
        this.commonId = commonId;
    }

    public String getCommonName() {
        return commonName;
    }

    public void setCommonName(String commonName) {
        this.commonName = commonName;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    public Long getBacklogTypeId() {
        return backlogTypeId;
    }

    public void setBacklogTypeId(Long backlogTypeId) {
        this.backlogTypeId = backlogTypeId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        BacklogCalendarViewResult that = (BacklogCalendarViewResult) o;
        return Objects.equals(commonId, that.commonId) &&
                Objects.equals(startDate, that.startDate) &&
                Objects.equals(endDate, that.endDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(commonId, startDate, endDate);
    }
}
