package pwc.taxtech.atms.dto.backlogManage;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import pwc.taxtech.atms.common.util.PwCIdSerialize;
import pwc.taxtech.atms.constant.enums.BackLogEnum;
import pwc.taxtech.atms.dto.didiFileUpload.DidiFileUploadDetailResult;
import pwc.taxtech.atms.vat.entity.BacklogConfig;
import pwc.taxtech.atms.vat.entity.BacklogConfigCommon;
import pwc.taxtech.atms.vat.entity.FileUpload;

import java.io.Serializable;
import java.util.List;

public class BacklogConfigResult extends BacklogConfig implements Serializable {


    private static final long serialVersionUID = -8578759102920950901L;
    @JsonSerialize(using = PwCIdSerialize.class)
    private Long id;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long backlogTypeId;

    @JsonSerialize(using = PwCIdSerialize.class)
    private Long commonId;

    private Boolean autoFlag;

    private String groupCode;

    private Integer generateType;

    private String orgName;

    private String businessLineName;

    private String dealUserName;

    private String auditUserName;

    private String createUserName;

    private List<DidiFileUploadDetailResult> fileUploads;

    public String getGroupCode() {
        return groupCode;
    }

    public void setGroupCode(String groupCode) {
        this.groupCode = groupCode;
    }

    public Long getBacklogTypeId() {
        return backlogTypeId;
    }

    public void setBacklogTypeId(Long backlogTypeId) {
        this.backlogTypeId = backlogTypeId;
    }

    public Boolean getAutoFlag() {
        return autoFlag;
    }

    public void setAutoFlag(Boolean autoFlag) {
        this.autoFlag = autoFlag;
    }

    public Integer getGenerateType() {
        return generateType;
    }

    public void setGenerateType(Integer generateType) {
        this.generateType = generateType;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getBusinessLineName() {
        return businessLineName;
    }

    public void setBusinessLineName(String businessLineName) {
        this.businessLineName = businessLineName;
    }

    public String getDealUserName() {
        return dealUserName;
    }

    public void setDealUserName(String dealUserName) {
        this.dealUserName = dealUserName;
    }

    public String getAuditUserName() {
        return auditUserName;
    }

    public void setAuditUserName(String auditUserName) {
        this.auditUserName = auditUserName;
    }

    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    public String getStatusStr() {
        return BackLogEnum.ConfigStatus.MAPPING.get(super.getStatus());
    }

    public String getGenerateTypeStr() {
        return BackLogEnum.GenerateType.MAPPING.get(this.getGenerateType());
    }

    public String getAutoFlagStr() {
        return BackLogEnum.AutoFlagType.MAPPING.get(this.autoFlag);
    }

    public List<DidiFileUploadDetailResult> getFileUploads() {
        return fileUploads;
    }

    public void setFileUploads(List<DidiFileUploadDetailResult> fileUploads) {
        this.fileUploads = fileUploads;
    }

    @Override
    public Long getId() {
        return id;
    }

    @Override
    public void setId(Long id) {
        this.id = id;
    }

    @Override
    public Long getCommonId() {
        return commonId;
    }

    @Override
    public void setCommonId(Long commonId) {
        this.commonId = commonId;
    }
}
