﻿infrastructureModule.controller('linkController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'interactionService', '$filter', 'apiInterceptor', 'jqFetch',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, interactionService, $filter, apiInterceptor, jqFetch) {

            $scope.localData = {};
            $scope.pagingOptions = {
                totalItems: 10,  //总数据
            };

            $scope.loadMainData = function () {
                var config = {
                    params: {}
                };
                interactionService.getLinkList(config).then(function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning("没有数据");
                        return;
                    }
                    $scope.dataGridUpdate(data);
                })
            };
            $scope.dataGridUpdate = function (_data) {
                $scope.localData = _data;
                $scope.pagingOptions = {
                    totalItems: $scope.localData.length,  //总数据
                };
                $scope.dataGridOptions = {
                    // dataSource: {
                    //     store: $scope.localData.items,
                    //     reshapeOnPush: true
                    // },
                    bindingOptions: {
                        dataSource: 'localData',
                    },
                    // repaintChangesOnly: true,
                    // twoWayBindingEnabled: true,
                    showBorders: true,
                    paging: {
                        enable: true,
                        pageIndex: 0,
                        pageSize: 10
                    },
                    pager: {
                        allowedPageSizes: 5,
                        infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                        showInfo: true,
                        showNavigationButtons: true,
                        showPageSizeSelector: true,
                        visible: true
                    },
                    searchPanel: {//查询
                        highlightCaseSensitive: true,
                        highlightSearchText: true,
                        searchVisibleColumnsOnly: false,
                        text: "",
                        width: 518,
                        visible: true,
                        placeholder: $translate.instant('Search'),
                    },
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    'export': {
                        allowExportSelectedData: false,//允许选择导出
                        customizeExcelCell: null,
                        enabled: true,//允许导出
                        excelFilterEnabled: false,
                        excelWrapTextEnabled: false,
                        fileName: "shareManage",//名字
                        ignoreExcelErrors: true,

                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: [
                        {
                            dataField: "title",
                            caption: $translate.instant('ContentTitle'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.title) {
                                        $('<span ' + style + '>').text(options.data.title).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },

                        {
                            dataField: "url",
                            caption: $translate.instant('LinkChoice'),
                            show: false,
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.url) {
                                        $('<span ' + style + '>').text(options.data.url).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createBy",
                            caption: $translate.instant('Creator'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createBy) {
                                        $('<span ' + style + '>').text(options.data.createBy).appendTo(container);
                                    } else {
                                        $('<span>').text("").appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "createTime",
                            caption: $translate.instant('CreatedTime'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {

                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';
                                    if (options.data.createTime) {
                                        $('<span ' + style + '>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "delFlag",
                            caption: $translate.instant('IsDisplay'),
                            allowHeaderFiltering: true,
                            cellTemplate: function (container, options) {
                                try {
                                    var style = options.data.essenceFlag == 1 ? '' : 'style="color:#999"';

                                    $('<span ' + style + '>').text($scope.delType(options.data.delFlag)).appendTo(container);

                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },

                        {
                            dataField: "operation",
                            caption: $translate.instant('Operation'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    var eventTarget = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("Edit") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTarget.off('click').on('click', function () {
                                        $scope.openEditPop(options.data);
                                    });
                                    var eventTargetDel = $('<a style="color:#506bf7;" data-id="' + options.data.id + '" href="javascript:void(0)"><span>' + $translate.instant("cellCommentDelete") + '</span></a><span style="width: 10px;display: inline-block"></span>');
                                    eventTargetDel.off('click').on('click', function () {
                                        $scope.deleteLink(options.data);
                                    });

                                    eventTarget.appendTo(container);
                                    eventTargetDel.appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                    ],
                    rowAlternationEnabled: false  //单双行颜色
                };
            };


            $scope.getTableHeight = function () {
                var row_height = $("table").find("tr").height();
                if (row_height) {
                    return {
                        height: (row_height * 12 + 100) + "px"
                    }
                }
            };
            $scope.addLink = function () {

                $scope.moduleTitle=$translate.instant('addLink');
                $scope.editType = 0;
                $scope.title = '';
                $scope.url = '';
                $('#postMessage').modal();

            };

            //修改
            var editTaxManage = function (item) {
                $scope.moduleTitle=$translate.instant('editLink');
                jqFetch.get(apiInterceptor.webApiHostUrl + '/Link/' + item.id).then(
                    function (data, status, headers) {


                        $scope.title = data.data.title;
                        $scope.url = data.data.url;
                        $scope.editType = 1;
                        $scope.LinkId = data.data.id;
                        $('#postMessage').modal();
                    })


            };

            //新增或者修改
            var postMessageSubmit = function () {
                if ($scope.title == undefined || $scope.title == '') {
                    SweetAlert.info("请输入标题");
                    return false;
                }
                if ($scope.url == undefined || $scope.url == '') {
                    SweetAlert.info("请输入链接");
                    return false;
                }
                var message = {
                    title: $scope.title,
                    url: $scope.url
                };
                if ($scope.editType == 0) {
                    jqFetch.post(apiInterceptor.webApiHostUrl + '/Link/add', message).then(
                        function (data, status, headers) {
                            if (status === 204) {
                                SweetAlert.warning("没有数据");
                                return;
                            }
                            $scope.title = '';
                            $scope.url = '';
                            $scope.loadMainData();
                        })
                }
                else if ($scope.editType == 1) {
                    message.id = $scope.LinkId;
                    jqFetch.post(apiInterceptor.webApiHostUrl + '/Link/edit', message).then(
                        function (data, status, headers) {
                            if (status === 204) {
                                SweetAlert.warning("没有数据");
                                return;
                            }
                            $scope.title = '';
                            $scope.url = '';
                            $scope.loadMainData();
                        })
                }

            };

            //显示方式
            $scope.delType = function (type) {
                if (type == 1) {
                    return "不显示";
                }
                else {
                    return "显示";
                }
            };

            //删除
            $scope.deleteLink = function (item) {

                SweetAlert.swal({
                        title: '确定删除吗？',
                        text: '',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            var message = {};
                            jqFetch.post(apiInterceptor.webApiHostUrl + '/Link/delete/' + item.id, message).then(
                                function (data, status, headers) {
                                    if (data.code == -1) {
                                        SweetAlert.warning("删除失败");
                                        return;
                                    }
                                    swal.close();
                                    $scope.loadMainData();
                                });
                        } else {
                            swal.close();
                        }
                    });
            };


            var checkUserPermission = function () {
                    var list = [];
                    $scope.hasTagPermission = false;
                    var temp = constant.InteractionPermission;
                    list.push(temp.tagOperate.code);
                    $scope.$root.checkUserPermissionList(list).success(function (data) {
                        $scope.hasTagPermission = data[temp.tagOperate.code];
                    });
                }


            ;(function initialize() {
                $scope.editTaxManage = editTaxManage;
                $scope.loadMainData();
                checkUserPermission();
                $scope.postMessageSubmit = postMessageSubmit;
                //注册方法
                $scope.openEditPop = editTaxManage;
            })();
        }]);