﻿infrastructureModule
    .controller('OrganizationManageController', ['$scope', '$location', '$log', 'orgService', '$interval', 'uiGridTreeViewConstants', 'uiGridConstants', 'SweetAlert', 'projectService', '$translate', '$timeout', 'organizationStructureService', 'areaRegionService', 'apiInterceptor', 'businessUnitService', 'userService', 'roleService', '$q', 'permissionService', 'dimensionService', 'region', 'equityService', 'orgExtraService', 'loginContext',
        function ($scope, $location, $log, orgService, $interval, uiGridTreeViewConstants, uiGridConstants, SweetAlert, projectService, $translate, $timeout, organizationStructureService, areaRegionService, apiInterceptor, businessUnitService, userService, roleService, $q, permissionService, dimensionService, region, equityService, orgExtraService, loginContext) {
            'use strict';

            $scope.expanded = false;
            $scope.showOrgs = true;
            $scope.showSingle = false;
            $scope.selectNodeCount=0;
            $scope.startDate = new Date(2019, 0, 1);
            $scope.endDate = new Date(2019, 11, 31);

            $scope.showTaxRegInfoContent = true;
            $scope.showExtraRegInfoContent = true;

            $scope.showTaxRule = false;
            $scope.showReturnRateInfo = false;
            $scope.showAccountingRateInfo = false;
            $scope.showApprovedLevyInfo = false;
            $scope.showTaxOfficerInfo = false;
            $scope.showInvoiceInfo = false;
            $scope.showTaxpayerQualification = false;
            $scope.showEmployee = false;
            $scope.isInternational = false;
            $scope.isNotHundred = false;
            $scope.editOrgExtraModel = {};

            var translate = {
                Enabled: $translate.instant('BusinessUnitActive'),  //已启用
                Disabled: $translate.instant('BusinessUnitDisabled')//已停用
            };

            var showWarning = function (resultMsg) {

                var errMsg = $translate.instant(resultMsg);
                SweetAlert.warning(errMsg);
            };

            var showSuccessMsg = function (resultMsg) {

                var errMsg = $translate.instant(resultMsg);
                SweetAlert.success(errMsg);
            };

            //jack
            $scope.getBottomHeight = function () {

                if ($scope.isLoadComplete) {
                    var y = $(".company-detail").height();
                    var parent = $('.org-right-container').height();
                    return {height: parent - y + 'px'};
                }

                return {};
            };

            $scope.visiableTaxRegInfo = function () {
                if ($scope.showTaxRegInfoContent) {
                    $scope.showTaxRegInfoContent = false;
                } else {
                    $scope.showTaxRegInfoContent = true;
                }
            };

            $scope.visiableTaxExtraInfo = function () {
                if ($scope.showExtraRegInfoContent) {
                    $scope.showExtraRegInfoContent = false;
                } else {
                    $scope.showExtraRegInfoContent = true;
                }
            };


            //初始化ack-pagination
            $scope.pagingOptions = {
                pageIndex: 1, //当前页码
                totalItems: 0, //总数据
                totalPages: 10, //总页数
                maxSize: 5, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
                pageSizeString: constant.page.pageSizeArrary[3].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage')
            };

            //初始化equityChangePagingOptions
            $scope.equityChangePagingOptions = {
                pageIndex: 1, //当前页码
                totalItems: 0, //总数据
                totalPages: 10, //总页数
                maxSize: 5, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
                pageSizeString: constant.page.pageSizeArrary[3].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage')
            };

            var getDimensionList = function () {
                dimensionService.getDimensionList().success(function (data) {
                    if (data) {
                        $scope.customDimensionList = data;

                        $log.debug($scope.customDimensionList);

                        $scope.businessName = dimension.getBusinessUnitName();
                        $scope.areaName = dimension.getAreaName();
                    }
                });
            };

            var dimension = {
                getBusinessUnitName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionID.businessUnitID;
                    });
                    if (findResult) {
                        return findResult.name;
                    } else {
                        return '';
                    }
                },
                getAreaName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionID.areaID;
                    });
                    if (findResult) {
                        return findResult.name;
                    } else {
                        return '';
                    }
                }
            };

            ////添加企业账套
            //$scope.newAccountSetModal = function ()
            //{
            //    $scope.accountSetOperateType = constant.Operation.Add;
            //    $scope.accountSetIsUpdate = false;

            //};

            // 机构树
            var tree;

            // 是佛启用禁用Map
            var isActiveMap = {
                false: 'Enable',
                true: 'Disable'
            };

            // 获取账套
            var loadEnterpriseAccountSetList = function () {
                // enterpriseAccountService.getEnterpriseAccountSetList().success(function (data) {
                //     // 只获取启用状态的账套
                //     //data = _.filter(data, function (num) { return num.isActive });
                //     $scope.enterpriseAccountSetList = sortByEnterpriseName(data);
                //     if (data && data.length > 0) {
                //         $scope.hasEnterpriseAccountSet = true;
                //
                //     } else {
                //         $scope.hasEnterpriseAccountSet = false;
                //     }
                // });
            };

            var dataType = {
                isPrefixNumber: function (value) {
                    var reg = /^\d+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixChar: function (value) {
                    var reg = /^[a-zA-Z]+/;
                    if (reg.test(value)) {
                        return true;
                    } else {
                        return false;
                    }
                },
                isPrefixNumberOrChar: function (value) {
                    if (dataType.isPrefixNumber(value)) {
                        return true;
                    }

                    if (dataType.isPrefixChar(value)) {
                        return true;
                    }

                    return false;
                }
            };

            var sortByEnterpriseName = function (data) {
                if (data && data.length > 0) {

                    var charList = [];
                    var nocharList = [];

                    data.forEach(function (row) {
                        if (dataType.isPrefixNumberOrChar(row.name)) {

                            row.nameSort = row.name;

                            if (row.nameSort) {
                                row.nameSort = row.nameSort.toLowerCase();
                            }
                            charList.push(row);
                        } else {
                            nocharList.push(row);
                        }

                    });

                    charList = _.sortBy(charList, 'nameSort');

                    nocharList = nocharList.sort(function compareFunction(param1, param2) {
                        return param1.name.localeCompare(param2.name, 'zh');
                    });

                    var all = _.union(charList, nocharList);
                    return all;
                }

                return data;
            };

            $scope.pagingService = {
                refreshEquityChangeListDataGrid: function () {
                    $log.debug("refreshOrgDataGrid");
                    getEquityChangeList($scope.selectCompany.name);
                }
            };

            var initPagingControl = function (totalItemsCount) {
                $scope.pagingOptions.totalItems = totalItemsCount;
            };

            var loadEquityDatagrid = function () {
                $scope.equityGridOptions = {
                    bindingOptions: {
                        dataSource: 'EquityList'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    /*paging: {
                        pageSize: 5
                    },
                    pager: {
                        showPageSizeSelector: true,
                        allowedPageSizes: [5, 10, 20],
                        showInfo: true
                    },*/
                    columns: [
                        {
                            dataField: "id",
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "eNum",
                            visible: false,
                            sortOrder: "asc",
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "organizationId",
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investorName",
                            caption: $translate.instant('InvestorName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investorEconomicNature",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('InvestorEconomicNature')
                        },
                        {
                            dataField: "certificateType",
                            caption: $translate.instant('CertificateType')
                        },
                        {
                            dataField: "idNum",
                            caption: $translate.instant('IdNum'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investmentCurrency",
                            caption: $translate.instant('InvestmentCurrency'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investmentAmount",
                            caption: $translate.instant('InvestmentAmount'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investmentRadio",
                            caption: $translate.instant('InvestmentRadio'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableShareholderName",
                            caption: $translate.instant('PayableShareholderName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableShareholderIdNum",
                            visible: false,
                            caption: $translate.instant('PayableShareholderIdNum'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableCapitalContributionCurrency",
                            caption: $translate.instant('PayableCapitalContributionCurrency'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableCapitalContributionAmount",
                            caption: $translate.instant('PayableCapitalContributionAmount'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableContributionProportion",
                            caption: $translate.instant('PayableContributionProportion'),
                            allowHeaderFiltering: false
                        }
                    ],
                    onContentReady: function (e) {
                        $scope.orgEquityListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll'),
                        }
                    }
                };

            };

            var loadEquityChangeDatagrid = function () {
                $scope.equityChangeGridOptions = {
                    bindingOptions: {
                        dataSource: 'EquityChangeList'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    keyExpr: "id",
                    /*paging: {
                        pageSize: 5
                    },
                    pager: {
                        showPageSizeSelector: true,
                        allowedPageSizes: [5, 10, 20],
                        showInfo: true
                    },*/
                    columns: [
                        {
                            dataField: "createTime",
                            caption: $translate.instant('RevisionDate'),
                            allowHeaderFiltering: false,
                            dataType: "date"
                        },
                        {
                            dataField: "comment",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('RevisionRemark')
                        },
                        {
                            dataField: "operationUser",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('Operator')
                        },
                        {
                            caption: $translate.instant('Operation'),
                            width: '10%',
                            cellTemplate: function (cellElement, cellInfo) {
                                if (cellInfo.rowIndex === 0) {
                                    var $button = $("<button>")
                                        .text("  撤销变更")
                                        .addClass("btn")
                                        .addClass("btn-in-grid")
                                        .on("click", $.proxy($scope.cancelEquityChange, this, cellInfo));
                                    cellElement.append($button);
                                }
                            }
                            /*cellTemplate: function (container, options) {
                                try {
                                    if(options.row.rowIndex===0){
                                        var button = $("<button>")
                                            .text("  撤销变更")
                                            .addClass("btn")
                                            .addClass("btn-in-grid")
                                            .on("click", $.proxy($scope.cancelEquityChange, this, cellInfo));
                                        button.appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }*/
                        }
                    ],
                    masterDetail: {
                        enabled: true,
                        template: "detail"
                    },
                    onContentReady: function (e) {
                        $scope.equityDetailInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll'),
                        }
                    }
                };
            };

            // 提交修改的机构其他信息
            $scope.cancelEquityChange = function (rowData) {
                SweetAlert.swal({
                        title: $translate.instant('ComfirmUpdate'),
                        text: $translate.instant('UpdateOrgExtraInfoTips'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            equityService.cancelChange(rowData.data.originalState, rowData.data.updateState).success(function (data) {
                                if (data) {
                                    SweetAlert.success($translate.instant('CancelChangeEquitySuccess'));
                                } else {
                                    SweetAlert.error($translate.instant('CancelChangeEquityFailed'));
                                }
                            });
                        }
                    });
            };

            $scope.getDetailGridSettings = function (key) {
                return {
                    //todo 绑定数据
                    dataSource: new DevExpress.data.DataSource({
                        load: function (loadOptions) {
                            if (key.rowIndex === 1) {
                                var deferred = $q.defer();
                                return equityService.getEquityById(key.data.id).success(function (response) {
                                    deferred.resolve({data: response, totalCount: response.length});
                                }).error(function () {
                                    deferred.reject("Data Loading Error");
                                });
                                return deferred.promise;
                            } else {
                                var deferred = $q.defer();
                                return equityService.getEquityHisById(key.data.id).success(function (response) {
                                    deferred.resolve({data: response, totalCount: response.length});
                                }).error(function () {
                                    deferred.reject("Data Loading Error");
                                });
                                return deferred.promise;
                            }
                        }
                    }),
                    columnAutoWidth: true,
                    showBorders: true,
                    columns: [
                        {
                            dataField: "id",
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "eNum",
                            visible: false,
                            sortOrder: "asc",
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "organizationId",
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investorName",
                            caption: $translate.instant('InvestorName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investorEconomicNature",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('InvestorEconomicNature')
                        },
                        {
                            dataField: "certificateType",
                            caption: $translate.instant('CertificateType')
                        },
                        {
                            dataField: "idNum",
                            caption: $translate.instant('IdNum'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investmentAmount",
                            caption: $translate.instant('InvestmentAmount'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investmentCurrency",
                            caption: $translate.instant('InvestmentCurrency'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "investmentRadio",
                            caption: $translate.instant('InvestmentRadio'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableShareholderName",
                            caption: $translate.instant('PayableShareholderName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableShareholderIdNum",
                            visible: false,
                            caption: $translate.instant('PayableShareholderIdNum'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableCapitalContributionAmount",
                            caption: $translate.instant('PayableCapitalContributionAmount'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableCapitalContributionCurrency",
                            caption: $translate.instant('PayableCapitalContributionCurrency'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "payableContributionProportion",
                            caption: $translate.instant('PayableContributionProportion'),
                            allowHeaderFiltering: false
                        }
                    ],
                    summary: {
                        totalItems: [{
                            column: "money",
                            customizeText: "总出资额(万元)",
                            summaryType: "sum"
                        }, {
                            column: "rate" + "%",
                            customizeText: "股权总比",
                            summaryType: "sum"

                        }]
                    }
                };
            };

            // var getEquityChangeList = function (name) {
            //     equityService.getChangeLogByOrgName(name).success(function (data) {
            //         if (data) {
            //             $scope.EquityChangeList = data;
            //             initPagingControl(data.length);
            //         }
            //     });
            // };

            var getEquityHistoryById = function (key) {
                if (key.rowIndex === 1) {
                    equityService.getEquityById(key.data.id).success(function (data) {
                        return data;
                    });
                } else {
                    equityService.getEquityHisById(key.data.id).success(function (data) {
                        return data;
                    });
                }
            };

            var loadTaxRuleDatagrid = function () {
                $scope.taxRuleGridOptions = {
                    bindingOptions: {
                        dataSource: 'TaxRuleGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [
                        {
                            dataField: "id",
                            visible: false,
                            allowHeaderFiltering: false,
                            caption: $translate.instant('id')
                        }, {
                            dataField: "index",
                            width: '5%',
                            allowHeaderFiltering: false,
                            caption: $translate.instant('SequenceNoCol')
                        }, {
                            dataField: "groupName",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('TaxGroup'),
                            lookup: {
                                dataSource: constant.GroupTypeList,
                                displayExpr: "type",
                                valueExpr: "type"
                            }
                        }, {
                            dataField: "taxDecCycle",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('TaxDecCycle'),
                            lookup: {
                                dataSource: constant.TaxDecCycleList,
                                displayExpr: "type",
                                valueExpr: "type"
                            }
                        }, {
                            dataField: "taxDecType",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('TaxDecType')
                        }
                    ],
                    onContentReady: function (e) {
                        $scope.TaxRuleListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertTaxRule(dataList).success(function (data) {
                            if (data) {
                                getTaxRuleList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateTaxRule(updateData).success(function (data) {
                            if (data) {
                                getTaxRuleList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteTaxRule(e.key.id).success(function (data) {
                            if (data) {
                                getTaxRuleList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getTaxRuleList = function (orgId) {
                orgExtraService.getTaxRuleListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.TaxRuleGridSource = data;
                        for (var i = 1; i <= $scope.TaxRuleGridSource.length; i++) {
                            $scope.TaxRuleGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableTaxRule = function () {
                if ($scope.showTaxRule) {
                    $scope.showTaxRule = false;
                } else {
                    $scope.showTaxRule = true;
                }
            };

            var loadInvoiceInfoDatagrid = function () {
                $scope.invoiceInfoGridOptions = {
                    bindingOptions: {
                        dataSource: 'InvoiceInfoGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [
                        {
                            dataField: "id",
                            visible: false,
                            allowHeaderFiltering: false,
                            caption: $translate.instant('id')
                        }, {
                            dataField: "index",
                            width: '5%',
                            allowHeaderFiltering: false,
                            caption: $translate.instant('SequenceNoCol')
                        }, {
                            dataField: "invoiceTypeName",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('InvoiceTypeName'),
                            lookup: {
                                dataSource: constant.InvoiceTypeList,
                                displayExpr: "type",
                                valueExpr: "type"
                            }
                        }, {
                            dataField: "unit",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('InvoiceUnit'),
                            lookup: {
                                dataSource: constant.InvoiceUnitList,
                                displayExpr: "type",
                                valueExpr: "type"
                            }
                        }, {
                            dataField: "monthlyMaxTicketsPurchased",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('MonthlyMaxTicketsPurchased')
                        }, {
                            dataField: "singleInvoicingMaxLimit",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('SingleInvoicingMaxLimit')
                        }, {
                            dataField: "offlineBillingTimeLimit",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('OfflineBillingTimeLimit')
                        }
                    ],
                    onContentReady: function (e) {
                        $scope.invoiceInfoListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertInvoice(dataList).success(function (data) {
                            if (data) {
                                getInvoiceInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateInvoice(updateData).success(function (data) {
                            if (data) {
                                getInvoiceInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteInvoice(e.key.id).success(function (data) {
                            if (data) {
                                getInvoiceInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getInvoiceInfoList = function (orgId) {
                orgExtraService.getInvoiceListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.InvoiceInfoGridSource = data;
                        for (var i = 1; i <= $scope.InvoiceInfoGridSource.length; i++) {
                            $scope.InvoiceInfoGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableInvoiceInfo = function () {
                if ($scope.showInvoiceInfo) {
                    $scope.showInvoiceInfo = false;
                } else {
                    $scope.showInvoiceInfo = true;
                }
            };


            var loadReturnRateInfoDatagrid = function () {

                var isShowClearButton = false;

                $scope.returnRateGridOptions = {
                    bindingOptions: {
                        dataSource: 'ReturnGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [{
                        dataField: "id",
                        visible: false,
                        allowHeaderFiltering: false,
                        caption: $translate.instant('id')
                    }, {
                        dataField: "index",
                        width: '5%',
                        allowHeaderFiltering: false,
                        caption: $translate.instant('SequenceNoCol')
                    }, {
                        dataField: "groupName",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('TaxGroup'),
                        width: '30%',
                        lookup: {
                            dataSource: constant.GroupTypeList,
                            displayExpr: "type",
                            valueExpr: "type"
                        }
                    },
                        {
                            dataField: "returnRate",
                            allowHeaderFiltering: false,
                            width: '15%',
                            caption: $translate.instant('ReturnRate')
                        },
                        {
                            dataField: "startDate",
                            allowHeaderFiltering: false,
                            width: '25%',
                            dataType: "date",
                            caption: $translate.instant('StartingDate')
                        }
                    ],
                    onContentReady: function (e) {
                        $scope.returnRateListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertReturnRate(dataList).success(function (data) {
                            if (data) {
                                getReturnRateInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateReturnRate(updateData).success(function (data) {
                            if (data) {
                                getReturnRateInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteReturnRate(e.key.id).success(function (data) {
                            if (data) {
                                getReturnRateInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll'),
                        }
                    }
                };
            };

            var getReturnRateInfoList = function (orgId) {
                orgExtraService.getReturnRateListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.ReturnGridSource = data;
                        for (var i = 1; i <= $scope.ReturnGridSource.length; i++) {
                            $scope.ReturnGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableReturnRateInfo = function () {
                if ($scope.showReturnRateInfo) {
                    $scope.showReturnRateInfo = false;
                } else {
                    $scope.showReturnRateInfo = true;
                }
            };

            var loadAccountingRateInfoDatagrid = function () {

                $scope.accountingRateGridOptions = {
                    bindingOptions: {
                        dataSource: 'AccountingRateGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [{
                        dataField: "id",
                        visible: false,
                        allowHeaderFiltering: false,
                        caption: $translate.instant('id')
                    }, {
                        dataField: "index",
                        width: '10%',
                        allowHeaderFiltering: false,
                        caption: $translate.instant('SequenceNoCol')
                    }, {
                        dataField: "rate",
                        allowHeaderFiltering: false,
                        width: '10%',
                        caption: $translate.instant('AccountingRate')
                    }, {
                        dataField: "currencyFrom",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('CurrencyFrom'),
                        width: '15%'
                    }, {
                        dataField: "currencyTo",
                        allowHeaderFiltering: false,
                        width: '15%',
                        caption: $translate.instant('CurrencyTo')
                    }, {
                        dataField: "startDate",
                        allowHeaderFiltering: false,
                        width: '20%',
                        dataType: "date",
                        caption: $translate.instant('StartingPeriod')
                    }, {
                        dataField: "endDate",
                        allowHeaderFiltering: false,
                        width: '20%',
                        dataType: "date",
                        caption: $translate.instant('EndPeriod')
                    }
                    ],
                    onContentReady: function (e) {
                        $scope.accountingRateListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertAccountingRate(dataList).success(function (data) {
                            if (data) {
                                getAccountingRateInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateAccountingRate(updateData).success(function (data) {
                            if (data) {
                                getAccountingRateInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteAccountingRate(e.key.id).success(function (data) {
                            if (data) {
                                getAccountingRateInfoList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getAccountingRateInfoList = function (orgId) {
                orgExtraService.getAccountingRateListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.AccountingRateGridSource = data;
                        for (var i = 1; i <= $scope.AccountingRateGridSource.length; i++) {
                            $scope.AccountingRateGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableAccountingRateInfo = function () {
                if ($scope.showAccountingRateInfo) {
                    $scope.showAccountingRateInfo = false;
                } else {
                    $scope.showAccountingRateInfo = true;
                }
            };

            var loadApprovedLevyDatagrid = function () {

                $scope.approvedLevyGridOptions = {
                    bindingOptions: {
                        dataSource: 'ApprovedLevyGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [{
                        dataField: "id",
                        visible: false,
                        allowHeaderFiltering: false,
                        caption: $translate.instant('id')
                    }, {
                        dataField: "index",
                        width: '5%',
                        allowHeaderFiltering: false,
                        caption: $translate.instant('SequenceNoCol')
                    }, {
                        dataField: "approvedLevyProject",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('ApprovedLevyProject'),
                        lookup: {
                            dataSource: constant.GroupTypeList,
                            displayExpr: "type",
                            valueExpr: "type"
                        },
                        width: '15%'
                    }, {
                        dataField: "approvedValidityPeriodStartTime",
                        allowHeaderFiltering: false,
                        width: '20%',
                        dataType: "date",
                        caption: $translate.instant('ApprovedValidityPeriodStartTime')
                    }, {
                        dataField: "approvedValidityPeriodEndTime",
                        allowHeaderFiltering: false,
                        width: '20%',
                        dataType: "date",
                        caption: $translate.instant('ApprovedValidityPeriodEndTime')
                    }, {
                        dataField: "approvedRate",
                        allowHeaderFiltering: false,
                        width: '10%',
                        caption: $translate.instant('ApprovedRate')
                    }, {
                        dataField: "approvedTaxPeriod",
                        allowHeaderFiltering: false,
                        width: '10%',
                        caption: $translate.instant('ApprovedTaxTerm'),
                        lookup: {
                            dataSource: constant.ApprovedLevyTermList,
                            displayExpr: "type",
                            valueExpr: "type"
                        }
                    }
                    ],
                    onContentReady: function (e) {
                        $scope.approvedLevyListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertApprovedLevyInfo(dataList).success(function (data) {
                            if (data) {
                                getApprovedLevyList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateApprovedLevyInfo(updateData).success(function (data) {
                            if (data) {
                                getApprovedLevyList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteApprovedLevyInfo(e.key.id).success(function (data) {
                            if (data) {
                                getApprovedLevyList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getApprovedLevyList = function (orgId) {
                orgExtraService.getApprovedLevyInfoListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.ApprovedLevyGridSource = data;
                        for (var i = 1; i <= $scope.ApprovedLevyGridSource.length; i++) {
                            $scope.ApprovedLevyGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableApprovedLevyInfo = function () {
                if ($scope.showApprovedLevyInfo) {
                    $scope.showApprovedLevyInfo = false;
                } else {
                    $scope.showApprovedLevyInfo = true;
                }
            };

            var loadTaxOfficerDatagrid = function () {
                $scope.taxOfficerGridOptions = {
                    bindingOptions: {
                        dataSource: 'TaxOfficerGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [{
                        dataField: "id",
                        visible: false,
                        allowHeaderFiltering: false,
                        caption: $translate.instant('id')
                    }, {
                        dataField: "index",
                        width: '5%',
                        allowHeaderFiltering: false,
                        caption: $translate.instant('SequenceNoCol')
                    }, {
                        dataField: "taxOfficerName",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('TaxOfficerName'),
                        width: '25%'
                    }, {
                        dataField: "taxOfficerPhoneNum",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('TaxOfficerPhoneNum'),
                        width: '25%'
                    }, {
                        dataField: "remark",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('TaxOfficerRemark'),
                        width: '25%'
                    }],
                    onContentReady: function (e) {
                        $scope.taxOfficerListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {
                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertTaxOfficer(dataList).success(function (data) {
                            if (data) {
                                getTaxOfficerList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateTaxOfficer(updateData).success(function (data) {
                            if (data) {
                                getTaxOfficerList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteTaxOfficer(e.key.id).success(function (data) {
                            if (data) {
                                getTaxOfficerList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getTaxOfficerList = function (orgId) {
                orgExtraService.getTaxOfficerListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.TaxOfficerGridSource = data;
                        for (var i = 1; i <= $scope.TaxOfficerGridSource.length; i++) {
                            $scope.TaxOfficerGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableTaxOfficerInfo = function () {
                if ($scope.showTaxOfficerInfo) {
                    $scope.showTaxOfficerInfo = false;
                } else {
                    $scope.showTaxOfficerInfo = true;
                }
            };

            var loadEmployeeDatagrid = function () {
                $scope.employeeGridOptions = {
                    bindingOptions: {
                        dataSource: 'EmployeeGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [{
                        dataField: "id",
                        visible: false,
                        allowHeaderFiltering: false,
                        caption: $translate.instant('id')
                    }, {
                        dataField: "index",
                        width: '5%',
                        allowHeaderFiltering: false,
                        caption: $translate.instant('SequenceNoCol')
                    }, {
                        dataField: "employeesNumStart",
                        allowHeaderFiltering: false,
                        caption: $translate.instant('EmployeesNumStart'),
                        width: '25%'
                    }, {
                        dataField: "employeesNumEnd",
                        allowHeaderFiltering: false,
                        width: '25%',
                        caption: $translate.instant('EmployeesNumEnd')
                    }, {
                        dataField: "statisticalMonth",
                        allowHeaderFiltering: false,
                        width: '15%',
                        dataType: "date",
                        caption: $translate.instant('StatisticalMonth')
                    }],
                    onContentReady: function (e) {
                        $scope.employeeListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertEmployee(dataList).success(function (data) {
                            if (data) {
                                getEmployeeList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateEmployee(updateData).success(function (data) {
                            if (data) {
                                getEmployeeList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteEmployee(e.key.id).success(function (data) {
                            if (data) {
                                getEmployeeList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getEmployeeList = function (orgId) {
                orgExtraService.getEmployeeListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.EmployeeGridSource = data;
                        for (var i = 1; i <= $scope.EmployeeGridSource.length; i++) {
                            $scope.EmployeeGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableEmployee = function () {
                if ($scope.showEmployee) {
                    $scope.showEmployee = false;
                } else {
                    $scope.showEmployee = true;
                }
            };

            var loadTaxpayerQualificationDatagrid = function () {
                $scope.taxpayerQualificationGridOptions = {
                    bindingOptions: {
                        dataSource: 'TaxpayerQualificationGridSource'
                    },
                    showBorders: true,
                    columnChooser: {
                        enabled: true
                    },
                    editing: {
                        mode: "row",
                        allowUpdating: true,
                        allowDeleting: true,
                        allowAdding: true
                    },
                    columns: [{
                        dataField: "id",
                        visible: false,
                        allowHeaderFiltering: false,
                        caption: $translate.instant('id')
                    }, {
                        dataField: "index",
                        width: '5%',
                        allowHeaderFiltering: false,
                        caption: $translate.instant('SequenceNoCol')
                    }, {
                        dataField: "taxpayerQualificationType",
                        allowHeaderFiltering: false,
                        width: '15%',
                        caption: $translate.instant('TaxpayerQualificationType'),
                        lookup: {
                            dataSource: constant.TaxpayerQualificationTypeList,
                            displayExpr: "type",
                            valueExpr: "type"
                        }
                    }, {
                        dataField: "determinationDate",
                        allowHeaderFiltering: false,
                        width: '15%',
                        dataType: "date",
                        caption: $translate.instant('DeterminationDate')
                    }, {
                        dataField: "validityStart",
                        allowHeaderFiltering: false,
                        width: '15%',
                        dataType: "date",
                        caption: $translate.instant('ValidityStart')
                    }, {
                        dataField: "validityEnd",
                        allowHeaderFiltering: false,
                        width: '15%',
                        dataType: "date",
                        caption: $translate.instant('ValidityEnd')
                    }
                    ],
                    onContentReady: function (e) {
                        $scope.taxpayerQualificationListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    onEditingStart: function (e) {
                    },
                    onInitNewRow: function (e) {

                    },
                    onRowInserting: function (e) {
                        var dataList = [];
                        var rowData = e.data;
                        rowData.organizationId = $scope.selectCompany.id;
                        delete rowData.__KEY__;
                        dataList.push(rowData);
                        orgExtraService.insertTaxpayerQualification(dataList).success(function (data) {
                            if (data) {
                                getTaxpayerQualificationList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('SaveFail'));
                            }
                        });
                    },
                    onRowInserted: function (e) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                    },
                    onRowUpdating: function (e) {
                        var updateData = e.newData;
                        updateData.id = e.key.id;
                        orgExtraService.updateTaxpayerQualification(updateData).success(function (data) {
                            if (data) {
                                getTaxpayerQualificationList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('UpdateFail'));
                            }
                        });
                    },
                    onRowUpdated: function (e) {
                        SweetAlert.success($translate.instant('UpdateSuccess'));
                    },
                    onRowRemoving: function (e) {
                        orgExtraService.deleteTaxpayerQualification(e.key.id).success(function (data) {
                            if (data) {
                                getTaxpayerQualificationList($scope.selectCompany.id);

                            } else {
                                SweetAlert.error($translate.instant('DeleteFail'));
                            }
                        });
                    },
                    onRowRemoved: function (e) {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };
            };

            var getTaxpayerQualificationList = function (orgId) {
                orgExtraService.getTaxpayerQualificationListByOrgId(orgId).success(function (data) {
                    if (data) {
                        $scope.TaxpayerQualificationGridSource = data;
                        for (var i = 1; i <= $scope.TaxpayerQualificationGridSource.length; i++) {
                            $scope.TaxpayerQualificationGridSource[i - 1].index = i;
                        }
                    }
                });
            };

            $scope.visiableTaxpayerQualification = function () {
                if ($scope.showTaxpayerQualification) {
                    $scope.showTaxpayerQualification = false;
                } else {
                    $scope.showTaxpayerQualification = true;
                }
            };

            // 初始化函数
            var initOrg = function () {
                loadorgTree();
                getDimensionList();
                // loadEnterpriseAccountSetList();
                // loadEquityDatagrid();
                // loadEquityChangeDatagrid();
                // getServiceList();
                // 其他信息中的grid
                // loadTaxRuleDatagrid();
                // loadInvoiceInfoDatagrid();
                // loadReturnRateInfoDatagrid();
                // loadAccountingRateInfoDatagrid();
                // loadApprovedLevyDatagrid();
                // loadTaxOfficerDatagrid();
                // loadEmployeeDatagrid();
                // loadTaxpayerQualificationDatagrid();
            };

            var getOrgList = function () {
                orgService.getOrgInfoList().success(function (data) {
                    if (data) {
                        //data.forEach(function (row) {
                        //    if (row.userList) {
                        //        row.userListStr = _.map(row.userList, function (x) { return x.userName; }).join(constant.comma);
                        //    }
                        //});
                        // console.log("dat:" + JSON.stringify(data));
                        if (loginContext.userName && loginContext.userName.toLowerCase() === "simon") {
                            data = _.filter(data, function (row) {
                                return row && row.industryID === "10";
                            });
                        }
                        initPagingControl(data.length);
                        $scope.DataGridSource = data;
                        $scope.orgUserGridInstance.repaint();
                        $scope.orgUserGridInstance.refresh();
                        // console.log($scope.DataGridSource);
                        // console.log($scope.orgUserGridOptions);
                        $scope.oldData = angular.copy(data);
                        $scope.setGridHeight();
                    }
                });
            };

            // 保存启用、启用的操作结果
            $scope.updateIsActive = function () {
                $scope.isCanOrganizationIsActiveBtn = false;
                var isActive = !$scope.selectCompany.isActive;
                if (isActive) {
                    orgService.enableOrgs($scope.selectCompany.id).success(function () {
                        SweetAlert.success($translate.instant('EnableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('enabled success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;

                    });
                } else {
                    var list = [];
                    list.push($scope.selectCompany.id);
                    orgService.disableOrgs(list).success(function () {
                        SweetAlert.success($translate.instant('DisableUserSuccess'));

                        $scope.selectCompany.isActive = !$scope.selectCompany.isActive;
                        $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                        $log.debug('disabled orgs success!');
                        $scope.organizationId = $scope.selectCompany.id;
                        loadorgTree();
                    })['finally'](function () {
                        $scope.isCanOrganizationIsActiveBtn = true;
                    });
                }
                generalSelectCompanyText();
            };

            // 进入高级配置编辑状态
            $scope.editAdvancedConfigurationStatus = function () {
                $scope.selectCompany.isUpdate = true;
                setEnterpriseOrgRowList($scope.selectCompany);

                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {

                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {

                        row.templateGroupList = _.find($scope.serviceList, function (num) {
                            return num.id === row.serviceTypeID
                        }).templateGroupList;
                    });
                }

            };

            // 添加服务模板
            $scope.addOrganizationServiceTemplateGroupRow = function () {
                var row = {};

                $scope.selectCompany.isUpdate = true;
                $scope.selectCompany.organizationServiceTemplateGroupList.push(row);
            };

            // 验证账套
            $scope.checkEnterpriseAccountSetSelect = function (row) {
                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.enterpriseAccountSetSelectError = null;
                    return;
                }


                if (!row.enterpriseAccountSetID) {
                    row.enterpriseAccountSetSelectError = $scope.resources.OrganizationMsgEnterpriseAccountSetRequired;
                } else {
                    row.enterpriseAccountSetSelectError = null;
                }
            };

            // 删除企业账套
            $scope.deleteAccountSet = function (row) {
                var index = jQuery.inArray(row, $scope.selectCompany.enterpriseAccountSetOrgList);
                $scope.selectCompany.enterpriseAccountSetOrgList.splice(index, 1);
            };

            // 删除服务
            $scope.deleteService = function (row) {
                var index = jQuery.inArray(row, $scope.selectCompany.organizationServiceTemplateGroupList);
                $scope.selectCompany.organizationServiceTemplateGroupList.splice(index, 1);
            };

            // 保存高级配置修改
            $scope.saveAdvancedConfiguration = function () {

                if (checkEnterpriseSetOrg() || checkTemplateList() || checkServiceTypeList()) {
                    return;
                }

                var branch = {
                    data: {
                        id: $scope.selectCompany.id
                    }
                };

                orgService.updateOrg($scope.selectCompany).success(function (data) {
                    if (data && !data.result) {
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return;
                    }

                    SweetAlert.success($translate.instant('SaveSuccess'));

                    $scope.selectOrganization(branch);
                });
            };

            // 取消高级配置修改
            $scope.cancelAdvancedConfiguration = function () {
                $scope.selectCompany.enterpriseAccountSetOrgList = angular.copy($scope.backups.enterpriseAccountSetOrgList);
                $scope.selectCompany.organizationServiceTemplateGroupList = angular.copy($scope.backups.organizationServiceTemplateGroupList);
                $scope.selectCompany.isUpdate = false;
            };

            // 关于日志部分
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
            };

            // 添加机构
            $scope.addOrg = function () {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.isAdd = true;
                $scope.selectedOrg = null;
            };

            // 编辑机构
            $scope.updateOrg = function () {
                $scope.isAdd = false;
                $scope.orgOperateType = constant.Operation.Edit;
                $scope.selectedOrg = $scope.selectCompany;
            };

            // 编辑股权
            $scope.updateEquity = function () {
                $scope.isAdd = false;
                $scope.equityEditOperateType = constant.Operation.Edit;
                $scope.selectedOrg = $scope.selectCompany;
            };

            // 变更股权
            $scope.alterEquity = function () {
                $scope.isAdd = true;
                $scope.equityChangeOperateType = constant.Operation.Edit;
                $scope.selectedOrg = $scope.selectCompany;
            };

            // 编辑机构其他信息
            $scope.updateOrgExtra = function () {
                $('.tax-reg-info-content .col-sm-4 span').attr("hidden", "hidden");
                $('.tax-extra-info-content .col-sm-8 span').attr("hidden", "hidden");
                $('.extra-organization-info .right-option .button2position').removeAttr("hidden");
                $('.extra-organization-info .right-option .updOrgBtn').attr("hidden", "hidden");
                for (var i = 0; i < $('.tax-reg-info-content .col-sm-4 input').length; i++) {
                    $('.tax-reg-info-content .col-sm-4 input')[i].style.display = "inline";
                }
                for (var i = 0; i < $('.tax-reg-info-content .col-sm-4 select').length; i++) {
                    $('.tax-reg-info-content .col-sm-4 select')[i].style.display = "inline";
                }
                for (var i = 0; i < $('.tax-extra-info-content .col-sm-8 input').length; i++) {
                    $('.tax-extra-info-content .col-sm-8 input')[i].style.display = "inline";
                }
                for (var i = 0; i < $('.tax-extra-info-content .col-sm-8 select').length; i++) {
                    $('.tax-extra-info-content .col-sm-8 select')[i].style.display = "inline";
                }
                $scope.editOldData = angular.copy($scope.editOrgExtraModel);
                $scope.comExtraOldData = angular.copy($scope.selectCompanyExtra);
            };

            // 取消编辑机构其他信息
            // TODO 将这个方法添加到切换功能里
            $scope.updateOrgExtraCancel = function () {
                $scope.selectCompanyExtra = $scope.comExtraOldData;
                $scope.editOrgExtraModel = $scope.editOldData;
                generalSelectCompanyExtraText();
                cancelWebChange();
            };

            var cancelWebChange = function () {
                $('.tax-extra-info-content .col-sm-8 span').removeAttr("hidden");
                $('.tax-reg-info-content .col-sm-4 span').removeAttr("hidden");
                $('.extra-organization-info .right-option .button2position').attr("hidden", "hidden");
                $('.extra-organization-info .right-option .updOrgBtn').removeAttr("hidden");
                for (var i = 0; i < $('.tax-reg-info-content .col-sm-4 input').length; i++) {
                    $('.tax-reg-info-content .col-sm-4 input')[i].style.display = "none";
                }
                for (var i = 0; i < $('.tax-reg-info-content .col-sm-4 select').length; i++) {
                    $('.tax-reg-info-content .col-sm-4 select')[i].style.display = "none";
                }
                for (var i = 0; i < $('.tax-extra-info-content .col-sm-8 input').length; i++) {
                    $('.tax-extra-info-content .col-sm-8 input')[i].style.display = "none";
                }
                for (var i = 0; i < $('.tax-extra-info-content .col-sm-8 select').length; i++) {
                    $('.tax-extra-info-content .col-sm-8 select')[i].style.display = "none";
                }
            };

            // 提交修改的机构其他信息
            $scope.updateOrgExtraSubmit = function () {
                SweetAlert.swal({
                        title: $translate.instant('ComfirmUpdate'),
                        text: $translate.instant('UpdateOrgExtraInfoTips'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            // 选中
                            updateOrgExtraInfo($scope.selectCompany.id);
                        }
                    });
            };

            var updateOrgExtraInfo = function (id) {
                var editData = $scope.editOrgExtraModel;
                editData.organizationId = id;
                orgService.updateOrgExtraInfoByOrgId(editData).success(function (res) {
                    if (res && !res.result) {
                        SweetAlert.warning($translate.instant(res.resultMsg));
                        return;
                    }
                    if (res) {
                        orgService.getSingleOrgExtra(id).success(function (data) {
                            if (data == null) {
                                SweetAlert.warning($translate.instant(data.resultMsg));
                                return;
                            }
                            $scope.editOrgExtraModel = angular.copy(data);
                            $scope.selectCompanyExtra = data;
                            generalSelectCompanyExtraText();
                            cancelWebChange();
                            SweetAlert.success($translate.instant('OrganizationExtraInfoEditSuccess'));
                        });
                    }
                });
            };

            var generalSelectCompanyExtraText = function () {
                if ($scope.selectCompanyExtra.smallMeagerProfit != null) {
                    $scope.selectCompanyExtra.smallMeagerProfit = $scope.selectCompanyExtra.smallMeagerProfit ? "是" : "否";
                }
                if ($scope.selectCompanyExtra.listedCompany != null) {
                    $scope.selectCompanyExtra.listedCompany = $scope.selectCompanyExtra.listedCompany ? "是" : "否";
                }
                if ($scope.selectCompanyExtra.signTripartiteAgreement != null) {
                    $scope.selectCompanyExtra.signTripartiteAgreement =
                        $scope.selectCompanyExtra.signTripartiteAgreement ? "是" : "否";
                }
                if ($scope.selectCompanyExtra.completeRecordTotalInstitutions != null) {
                    $scope.selectCompanyExtra.completeRecordTotalInstitutions =
                        $scope.selectCompanyExtra.completeRecordTotalInstitutions ? "是" : "否";
                }
                if ($scope.selectCompanyExtra.regFinancialAccountingType != null) {
                    $scope.regFinancialAccountingTypeList.map(function (value, index) {
                        if (value.code === $scope.selectCompanyExtra.regFinancialAccountingType) {
                            $scope.selectCompanyExtra.regFinancialAccountingType = value.type;

                        }
                    });
                }
            };

            var generalSelectCompanyText = function () {
                if ($scope.selectCompany.engageNationalProhibitIndustry != null) {
                    $scope.selectCompany.engageNationalProhibitIndustryStr = $scope.selectCompany.engageNationalProhibitIndustry ? "是" : "否";
                }

                if ($scope.selectCompany.nationalEconomicIndustry != null) {
                    $scope.nationalEconomicIndustryList.map(function (value, index) {
                        if (value.code === $scope.selectCompany.nationalEconomicIndustry) {
                            $scope.selectCompany.nationalEconomicIndustryStr = value.code + "-" + value.type;

                        }
                    });
                    if (null == $scope.selectCompany.nationalEconomicIndustryStr || "" === $scope.selectCompany.nationalEconomicIndustryStr) {
                        $scope.selectCompany.nationalEconomicIndustryStr = $scope.selectCompany.nationalEconomicIndustry;
                    }
                }
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectCompany && !$scope.isAdd) {
                        $scope.organizationId = $scope.selectCompany.id;
                    } else {
                        $scope.organizationId = null;
                    }
                    initOrg();
                    $scope.isOrgUpdate = false;
                }
            });

            // 选中服务更改时
            $scope.serviceTypeChange = function (service) {
                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {
                    var sameServiceTypeIDList = _.filter($scope.selectCompany.organizationServiceTemplateGroupList, function (num) {
                        return num.serviceTypeID === service.serviceTypeID;
                    });

                    if (sameServiceTypeIDList && sameServiceTypeIDList.length > 1) {
                        service.serviceTypeError = $scope.resources.ServiceExists;
                    } else {
                        service.serviceTypeError = null;
                    }
                } else {
                    service.serviceTypeError = null;
                }

                service.templateGroupList = _.find($scope.serviceList, function (num) {
                    return num.id === service.serviceTypeID
                }).templateGroupList;

                service.templateGroupID = '';
            };

            // 判断服务的选择是否有错误
            var checkServiceTypeList = function () {
                var hasError = false;
                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {

                    var serviceTypeIDList = [];

                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {
                        if (serviceTypeIDList.indexOf(row.serviceTypeID) > -1) {
                            row.serviceTypeError = $scope.resources.ServiceExists;
                            hasError = true;
                        } else {
                            row.serviceTypeError = null;
                        }

                        if (!row.templateGroupID) {
                            hasError = true;
                            row.selectedTemplateError = $scope.resources.OrganizationMsgTemplateRequired;
                        } else {
                            row.selectedTemplateError = null;
                        }

                        serviceTypeIDList.push(row.serviceTypeID);
                    });

                    // 有错误
                    return hasError;
                }

                // 没有错误
                return hasError;
            };

            var loadRootOrg = function () {
                orgService.getSingleOrg(constant.guid.empty).success(function (rootOrg) {
                    $scope.rootOrg = rootOrg;
                });
            };
            //加载用户权限list
            var loadUserRoleList = function (orgID) {
                roleService.getUserRoleList(orgID, '', '').success(function (data) {
                    // 构造用户信息
                    var roleStaticsList = [];

                    var userRoleShowList = [];
                    if (data && data.length > 0) {
                        data.forEach(function (row) {

                            var uniqRoleList = _.uniq(row.roleInfoList, function (item) {
                                return item.name
                            });
                            row.roleNameList = _.map(uniqRoleList, function (x) {
                                return x.name;
                            }).join(constant.comma);

                            //var roleNames = _.pluck(row.roleInfoList, 'name');
                            //row.roleNameList = roleNames.join(',');

                            if (!row.isAccessible) {
                                row.roleNameList = $translate.instant('UnAccessable');
                            }

                            row.hasEditPermission = $scope.hasEditPermission;

                            userRoleShowList.push({id: row.id, userName: row.userName, roleNameList: row.roleNameList});
                            row.roleInfoList.forEach(function (role) {
                                var one = _.find(roleStaticsList, function (data) {
                                    return data.id === role.id;
                                });

                                if (one) {
                                    one.count++;
                                } else {
                                    role.count = 1;
                                    roleStaticsList.push(role);
                                }
                            });
                        });
                    }

                    $scope.roleStaticsList = roleStaticsList;

                    $scope.userRoleList = JSON.stringify(userRoleShowList);
                    $scope.userRoleGridOptions.data = data;
                    //用户数统计
                    $scope.userCount = data.length || 0;
                });
            };

            // TODO 跳转到账套界面
            $scope.jumpToAccount = function (enterpriseAccountSetID) {
                $location.path("/financialData/enterpriseAccountManage").search({
                    jumpingEnterpriseAccountSetID: enterpriseAccountSetID
                });

            };

            // 选中机构
            $scope.selectOrganization = function (branch) {


                var org = branch.data;
                $scope.output = "You selected: " + org.id;

                var suborgList = getSubOrgList(branch);
                $scope.selectedOrgID = org.id;
                // 选中事件
                // $scope.selectCompany = org;
                orgService.getSingleOrg(org.id).success(function (data) {
                    if($scope.selectNodeCount>1) {
                        $scope.showOrgs = false;
                        $scope.showSingle = true;
                    }
                    $scope.selectNodeCount++;
                    $scope.selectCompany = data;
                    $scope.selectCompany.isActiveStr = $translate.instant(isActiveMap[$scope.selectCompany.isActive]);
                    //$log.debug("org.regionID: " + org.regionID);
                    $scope.selectCompany.suborgList = suborgList;
                    $scope.backups = {};
                    $scope.backups.enterpriseAccountSetOrgList = angular.copy($scope.selectCompany.enterpriseAccountSetOrgList);
                    $scope.backups.organizationServiceTemplateGroupList = angular.copy($scope.selectCompany.organizationServiceTemplateGroupList);

                    var orgAttributeList = _.filter(data.dimensionValueOrgList, function (attr) {
                        if (attr.id) {
                            return true;
                        } else {
                            return false;
                        }
                    });

                    var orgAttributeRowList = [];

                    if (orgAttributeList && orgAttributeList.length > 0) {

                        $scope.firstAttribute = orgAttributeList[0];

                        for (var i = 1; i < orgAttributeList.length; i = i + 2) {
                            var model = {
                                left: orgAttributeList[i]
                            };
                            if (i + 1 < orgAttributeList.length) {
                                model.right = orgAttributeList[i + 1];
                            }
                            orgAttributeRowList.push(model);
                        }
                    }

                    $scope.selectCompany.orgAttributeRowList = orgAttributeRowList;

                    $scope.isInternational = $scope.selectCompany.oversea;
                    // $scope.editOrgExtraModel.unifiedSocialCreditCode = $scope.selectCompany.taxPayerNumber;
                    // $scope.selectCompanyExtra.unifiedSocialCreditCode = $scope.selectCompany.taxPayerNumber;
                    //加载用户权限list
                    loadUserRoleList(org.id);
                    generalSelectCompanyText();
                    cancelWebChange();

                    // $scope.updateOrgExtraCancel()
                });


                orgService.getSingleOrgExtra(org.id).success(function (data) {
                    if (data) {
                        $scope.selectCompanyExtra = data;
                        $scope.editOrgExtraModel = angular.copy(data);
                        generalSelectCompanyExtraText();
                    }
                });

                // getEquityListByOrgId(org.id);

                // todo 其他信息的grid可以移到label ng-click事件里做，lazyinit
                // getTaxRuleList(org.id);
                // getInvoiceInfoList(org.id);
                // getReturnRateInfoList(org.id);
                // getAccountingRateInfoList(org.id);
                // getApprovedLevyList(org.id);
                // getTaxOfficerList(org.id);
                // getEmployeeList(org.id);
                // getTaxpayerQualificationList(org.id);

                // equityService.getChangeLogByOrgName(org.name).success(function (data) {
                //     if (data) {
                //         $scope.EquityChangeList = data;
                //     }
                // });
            };

            $scope.resources = {
                EffectiveDateRequired: $translate.instant('EffectiveDateRequired'),
                ExpiredDateRequired: $translate.instant('ExpiredDateRequired'),
                EffectiveDateAreaProblem: $translate.instant('EffectiveDateAreaProblem'),
                OrganizationMsgTemplateRequired: $translate.instant('OrganizationMsgTemplateRequired'),
                OrganizationMsgProjectIndustryRequired: $translate.instant('OrganizationMsgProjectIndustryRequired'),
                ServiceExists: $translate.instant('ServiceExists'),
                DateMonthFormatError: $translate.instant('DateMonthFormatError')
            };


            $scope.collapseOrgExtraInfoAll = function () {
                $scope.showTaxRegInfoContent = false;
                $scope.showExtraRegInfoContent = false;
                $scope.showTaxRule = false;
                $scope.showReturnRateInfo = false;
                $scope.showAccountingRateInfo = false;
                $scope.showApprovedLevyInfo = false;
                $scope.showTaxOfficerInfo = false;
                $scope.showInvoiceInfo = false;
                $scope.showTaxpayerQualification = false;
                $scope.showEmployee = false;
                $scope.expanded = false;
            };
            $scope.expandOrgExtraInfoAll = function () {
                $scope.showTaxRegInfoContent = true;
                $scope.showExtraRegInfoContent = true;
                $scope.showTaxRule = true;
                $scope.showReturnRateInfo = true;
                $scope.showAccountingRateInfo = true;
                $scope.showApprovedLevyInfo = true;
                $scope.showTaxOfficerInfo = true;
                $scope.showInvoiceInfo = true;
                $scope.showTaxpayerQualification = true;
                $scope.showEmployee = true;
                $scope.expanded = true;
            };

            // 验证开始时间
            $scope.checkStartDate = function (row) {


                // if (!row.effectiveDateStr) {
                //     row.startDateError = $scope.resources.EffectiveDateRequired;
                // } else {
                //     row.startDateError = null;
                // }

                if (row.effectiveDateStr && !window.PWC.checkMonth(row.effectiveDateStr)) {
                    row.startDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.startDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.startDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {

                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 验证结束时间
            $scope.checkEndDate = function (row) {

                //结束时间可为空，默认9999-12
                // if (!row.expiredDateStr) {
                //     row.endDateError = $scope.resources.ExpiredDateRequired;
                // } else {
                //     row.endDateError = null;
                // }

                if (row.expiredDateStr && !window.PWC.checkMonth(row.expiredDateStr)) {
                    row.endDateError = $scope.resources.DateMonthFormatError;
                    return;
                } else {
                    row.endDateError = null;
                }

                if (!row.enterpriseAccountSetID && !row.effectiveDateStr && !row.expiredDateStr) {
                    row.endDateError = null;
                    return;
                }

                if (row.effectiveDateStr && row.expiredDateStr) {
                    if (!validateDate(row.effectiveDateStr, row.expiredDateStr)) {
                        row.startDateError = $scope.resources.EffectiveDateAreaProblem;
                    } else {
                        row.startDateError = null;
                    }
                }
            };

            // 加载机构树
            $scope.my_tree = tree = {};

            var loadorgTree = function () {

                $scope.orgList = [];
                $scope.doing_async = true;

                $scope.showOrgTree = false;

                orgService.getOrgListToJson(1).success(function (data) {
                    $scope.orgList = data;
                    $log.debug(data);
                    // 设置默认选中机构
                    if (data && data.length > 0) {

                        var selectOrg = data[0];
                        if ($scope.organizationId) {
                            selectOrg = findBranch($scope.organizationId, $scope.orgList);
                            if (!selectOrg) {
                                selectOrg = data[0];
                            }
                        }

                        $scope.selectOrganization(selectOrg);
                    }

                    $scope.doing_async = false;

                    return $timeout(function () {
                        $scope.my_tree.expand_level_function();
                        $scope.my_tree.select_branch(selectOrg);
                        $scope.showOrgTree = true;
                    }, 200);

                    return tree.expand_level_function();

                }).error(function (data) {

                    $log.debug(JSON.stringify(data));
                });
            };

            // 查找选中的分支
            var findBranch = function (orgid, orgTree) {
                if (orgTree && orgTree.length > 0) {

                    for (var i = 0; i < orgTree.length; i++) {
                        var row = orgTree[i];

                        // 查看当前节点
                        if (row.data.id === orgid) {
                            target = row;
                            return target;
                        }

                        // 查看子节点
                        var target = findBranch(orgid, row.children);
                        if (target) {
                            return target;
                        }
                    }

                    return null;
                } else {
                    return null;
                }
            };

            // Copy Array
            var copyArray = function (data) {
                var ret = [];
                data.forEach(function (row) {

                    ret.push(row);
                });

                return ret;
            };

            // 修改机构时，设置账套设置的值
            var setEnterpriseOrgRowList = function (enterpriseAccountSetData) {
                $scope.orgAccountList = [];
                if (!enterpriseAccountSetData.enterpriseAccountSetOrgList || enterpriseAccountSetData.enterpriseAccountSetOrgList.length === 0) {
                    return;
                }
                var enterpriseAccountSetList = copyArray($scope.enterpriseAccountSetList);

                var index = 1;
                $scope.OrgAccountRowIndex = index;
                enterpriseAccountSetData.enterpriseAccountSetOrgList.forEach(function (row) {

                    row.fromID = 'advancedSetFrom' + index;
                    row.toID = 'advancedSetTo' + index;

                    index++;
                    $scope.OrgAccountRowIndex = index;

                    $timeout(function () {
                        setDatepickerRow(row);
                    }, 100);
                });

            };

            var setDatepickerRow = function (rowData) {
                $("#" + rowData.fromID).datepicker({
                    minViewMode: 1,
                    autoclose: true,
                    language: region,
                    format: "yyyy-mm"
                });

                $("#" + rowData.toID).datepicker({
                    minViewMode: 1,
                    autoclose: true,
                    language: region,
                    format: "yyyy-mm"
                });

                $("#" + rowData.fromID).on('changeDate', function () {
                    var fromValue = $("#" + rowData.fromID).val();
                    var toValue = $("#" + rowData.toID).val();
                    if (fromValue) {
                        // 如果结束值为空，或者有效时间是一个时间段，则设置结束时间的开始时间
                        if (!toValue || validateDate(fromValue, toValue)) {
                            $("#" + rowData.toID).datepicker('setStartDate', fromValue);
                        }
                    }
                });

                // 默认的错误信息先设置为空
                rowData.startDateError = null;
                rowData.endDateError = null;
            };

            // 获取所有服务列表
            // var getServiceList = function () {
            //     projectService.getServiceList().success(function (serviceListData) {
            //         $scope.serviceList = serviceListData;
            //     });
            // };

            // 验证是否为时间段
            var validateDate = function (from, to) {
                var fromDate = new Date(from + '-01');
                var toDate = new Date(to + '-01');
                toDate.setMonth(toDate.getMonth() + 1);
                toDate.setDate(toDate.getDate() - 1);

                if (fromDate <= toDate) {
                    return true;
                } else {
                    return false;
                }
            };

            // 验证账套修改
            var checkEnterpriseSetOrg = function () {

                var enterpriseSetList = [];
                if ($scope.selectCompany.enterpriseAccountSetOrgList && $scope.selectCompany.enterpriseAccountSetOrgList.length > 0) {
                    $scope.selectCompany.enterpriseAccountSetOrgList.forEach(function (row) {

                        $scope.checkEnterpriseAccountSetSelect(row);
                        $scope.checkStartDate(row);
                        $scope.checkEndDate(row);

                        if (row.enterpriseAccountSetID) {
                            enterpriseSetList.push(row);
                        }
                    });
                }

                $scope.selectCompany.enterpriseAccountSetOrgList = enterpriseSetList;

                var errorList = _.filter($scope.selectCompany.enterpriseAccountSetOrgList, function (num) {

                    return num.enterpriseAccountSetSelectError || num.startDateError || num.endDateError;
                });

                if (errorList && errorList.length > 0) {
                    return true;
                } else {
                    return false;
                }
            };

            // 验证模板列表
            var checkTemplateList = function () {
                var hasError = false;
                if ($scope.selectCompany.organizationServiceTemplateGroupList && $scope.selectCompany.organizationServiceTemplateGroupList.length > 0) {
                    $scope.selectCompany.organizationServiceTemplateGroupList.forEach(function (row) {
                        $scope.checkTemplate(row);
                        if (row.selectedTemplateError) {
                            hasError = true;
                        }
                    });
                }

                return hasError;
            };

            // 验证模板方法
            $scope.checkTemplate = function (row) {
                if (!row.templateGroupID) {

                    row.selectedTemplateError = $scope.resources.OrganizationMsgTemplateRequired;

                } else {
                    row.selectedTemplateError = null;
                }
            };

            // 获取当前机构下的子机构
            var getSubOrgList = function (branch) {

                var orgList = [];

                if (branch.children && branch.children.length > 0) {
                    branch.children.forEach(function (row) {
                        orgList.push(row.data);
                        var tempList = getSubOrgList(row);
                        if (tempList && tempList.length > 0) {
                            orgList = _.union(orgList, tempList);
                        }
                    });
                }

                return orgList;
            };

            var initUserRoleUIGrid = function () {
                $scope.UIGridColumns = [{
                    field: 'userName',
                    name: $translate.instant('UserTitleName'),
                    width: '30%',
                    headerCellClass: 'right',
                    enableFiltering: false,
                    cellTemplate: '<div class="ui-grid-cell-contents right"><span title="{{row.entity.userName}}">{{row.entity.userName}}<span></div>'
                }];

                if ($scope.hasEditPermission) {

                    var colum = {
                        field: 'roleNameList',
                        name: $translate.instant('RoleDesc'),
                        width: '60%',
                        headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.roleNameList}}<span></div>'
                    };

                    $scope.UIGridColumns.push(colum);

                    colum = {
                        name: $translate.instant('Operation'),
                        width: '10%',
                        field: 'Operation',
                        headerCellClass: 'center',
                        enableFiltering: false,
                        cellTemplate: '<div class="project-manage-grid-operation ui-grid-cell-contents">' +
                        '<span ng-click="grid.appScope.updateUserRole(row.entity)" class="operate-span" role="button" tabindex="0" aria-hidden="false" style=""><i class="material-icons middle black-color">create</i></span>' +
                        '<span ng-click="grid.appScope.deleteUserRole(row.entity)" class="operate-span" role="button" tabindex="0" aria-hidden="false" style=""><i class="material-icons button-icons icon-delete">delete</i></span>' +
                        '</div>'
                    };
                    $scope.UIGridColumns.push(colum);

                } else {
                    var columns = {
                        field: 'roleNameList',
                        name: $translate.instant('RoleDesc'),
                        width: '70%',
                        headerCellClass: '',
                        cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.roleNameList}}<span></div>'
                    };
                    $scope.UIGridColumns.push(columns);
                }

                $scope.userRoleGridOptions = {
                    rowHeight: 30,
                    selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
                    enableFullRowSelection: true,
                    enableRowSelection: true,
                    enableSorting: false,
                    enableFiltering: false,
                    enableColumnMenus: false,
                    enableRowHeaderSelection: false,
                    multiSelect: false,
                    enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
                    columnDefs: $scope.UIGridColumns,
                    onRegisterApi: function (gridApi) {
                        $scope.gridApi = gridApi;
                        $interval(function () {
                            $scope.gridApi.core.handleWindowResize();
                        }, 500, 60 * 60 * 8);
                    }
                };
            };


            //如果添加了用户，则写入该机构下的库
            $scope.$watch('addUserIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    if ($scope.selectedKeyItems && $scope.selectedUserList.length > 0) {
                        // console.log(JSON.stringify($scope.selectedUserList));
                        addUserToOrg($scope.selectedUserList);
                    }
                }
            });

            //为当前机构添加用户
            var addUserToOrg = function (selectedUserArray) {

                var selectedArr = [];

                if (selectedUserArray && selectedUserArray.length > 0) {
                    for (var i = 0; i < selectedUserArray.length; i++) {
                        ////用户的角色列表
                        //var roleList = selectedUserArray[i].roleInfoList;

                        //去掉在当前机构下存在的用户,当前用户的权限可能已经改动过
                        var isUserExist = _.find($scope.userRoleGridOptions.data, function (num) {
                            return num.userID == selectedUserArray[i].userID;
                        });

                        if (isUserExist) {
                            continue;
                        }

                        var selectedObject = {
                            id: PWC.newGuid(),
                            userID: selectedUserArray[i].userID,
                            organizationID: $scope.selectedOrgID,
                            IsAccessible: true,
                            hasOriginalRole: true
                        };

                        selectedArr.push(selectedObject);
                    }
                }

                if (selectedArr.length > 0) {
                    userService.updateUserRoleForOrg(selectedArr).success(function (data) {
                        if (data) {
                            showSuccessMsg("SaveSuccess");
                            //重新加载用户list
                            loadUserRoleList($scope.selectedOrgID);
                        }
                    });
                } else {
                    showWarning('UserExists');
                }
            };

            //添加用户，弹框，call指令 add-exist-user-modal
            $scope.addUser = function () {
                var selectedKeyItem = [];
                $scope.userRoleGridOptions.data.forEach(function (row) {
                    selectedKeyItem.push(row.id);
                });
                $scope.addUserOperateType = constant.Operation.Add;
                $scope.addUserIsUpdate = false;
                $scope.selectedKeyItems = selectedKeyItem;
            };
            $scope.permissionPopover = {
                //content: $scope.permissionList,
                templateUrl: 'permissionPopoverTemplate.html',
                title: $translate.instant('TPermission')
            };

            //Jack
            $scope.showPermission = function (item) {

                var roleID = item.id;
                $scope.permissionList = [];
                var currentPermission = _.find($scope.allRolePermission, function (row) {
                    return row.roleID == roleID;
                });
                if (currentPermission && currentPermission.permissionList) {
                    $scope.permissionList = currentPermission.permissionList;
                    var copyData = angular.copy(currentPermission.permissionList);
                    copyData.forEach(function (item) {
                        var findParent = _.find(currentPermission.permissionList, function (num) {
                            return num.id === item.parentID;
                        });
                        if (!findParent) {
                            item.parentID = null;
                        }
                    });

                    $scope.permissionTreeViewData = copyData;// currentPermission.permissionList;
                    // console.log(JSON.stringify($scope.permissionTreeViewData));
                }
                // console.log(JSON.stringify(item));
            };


            var getAllRolePermission = function () {
                roleService.getAllRolePermission(constant.serviceType.VAT).success(function (data) {
                    if (data) {
                        $scope.allRolePermission = data;
                        //console.log('all permission: '+JSON.stringify(data));
                    }
                });
            };

            // var getEquityListByOrgId = function (orgId) {
            //     equityService.getEquityList(orgId).success(function (data) {
            //         if (data) {
            //             $scope.EquityList = data;
            //             var amountTotal = 0;
            //             var proportionTotal = 0;
            //             for (var i = 0; i < data.length; i++) {
            //                 amountTotal += data[i].payableCapitalContributionAmount;
            //                 proportionTotal += data[i].payableContributionProportion;
            //             }
            //             $scope.EquitySumInfo = {
            //                 orgTotal: data.length,
            //                 amountTotal: amountTotal,
            //                 proportionTotal: proportionTotal
            //             };
            //             if ($scope.EquitySumInfo.proportionTotal !== 100) {
            //                 $scope.isNotHundred = true;
            //             } else {
            //                 $scope.isNotHundred = false;
            //             }
            //         } else {
            //             SweetAlert.warning($translate.instant('NoEquityInfo'));
            //         }
            //     });
            // };

            // $scope.refreshEquityList = function () {
            //     // getEquityListByOrgId($scope.selectCompany.id);
            //     // getEquityChangeList($scope.selectCompany.name);
            // };

            var confirmWarningWindow = function (title, text) {
                var deferred = $q.defer();
                SweetAlert.swal({
                        title: title,
                        text: text,
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        deferred.resolve(isConfirm);
                    });

                return deferred.promise;
            };

            //删除用户角色
            $scope.deleteUserRole = function (userModel) {

                var confirmToDelete = $translate.instant('ConfirmToDelete');

                confirmWarningWindow(confirmToDelete, '').then(function (data) {
                    if (data) {
                        var userOrgDto = {
                            userID: userModel.id,
                            OrgID: $scope.selectedOrgID
                        };
                        //$log.debug(JSON.stringify(userModel));
                        userService.deleteUserRoleForOrg(userOrgDto).success(function (data) {
                            showSuccessMsg("OrganizationStructureDeleteSuccess");
                            //重新加载用户list
                            loadUserRoleList($scope.selectedOrgID);

                        });
                    }
                });
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('userRolesIsUpdate', function (newValue, oldValue) {
                if (newValue) {
                    //重新加载用户list
                    loadUserRoleList($scope.selectedOrgID);
                }
            });

            //编辑用户角色
            $scope.updateUserRole = function (userRole) {
                $scope.userRoleOperateType = constant.Operation.Edit;
                $scope.selectedOrgID = $scope.selectedOrgID;
                $scope.selectedUserID = userRole.id;
                $scope.userRolesIsUpdate = false;
            };

            // 添加一行账套设置 (jack)
            $scope.newOrgAccountRow = function () {
                var index = $scope.OrgAccountRowIndex;
                var enterpriseAccountSetList = copyArray($scope.enterpriseAccountSetList);
                var d = new Date();
                var now = d.formatDateTime('yyyy-MM');

                var row = {
                    enterpriseAccountSetName: '',
                    effectiveDateStr: null,
                    expiredDateStr: null,
                    organizationID: $scope.selectedOrgID,
                    fromID: 'advancedSetFrom' + index,
                    toID: 'advancedSetTo' + index
                };

                $scope.OrgAccountRowIndex++;
                $scope.selectCompany.enterpriseAccountSetOrgList.push(row);
                $timeout(function () {
                    setDatepickerRow(row);
                }, 200);
            };


            $scope.getGridHeight = function () {
                return {height: $(".dx-viewport").height() + "px"};
            };

            //获取当前角色对应的权限列表
            var loadPermissionTree = function () {
                $scope.permissionTreeViewOptions = {
                    bindingOptions: {
                        dataSource: 'permissionTreeViewData',
                        expandAllEnabled: 'expandAll'
                    },
                    dataStructure: "plain",
                    selection: {
                        mode: "single"
                    },
                    loadPanel: {
                        enabled: true
                    },
                    scrolling: {
                        mode: "virtual"
                    },
                    parentIdExpr: "parentID",
                    keyExpr: "id",
                    displayExpr: 'name',
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,
                    showBorders: true,
                    selectAllText: $translate.instant('SelectAll'),
                    scrollDirection: 'vertical',  //Accepted Values: 'vertical' | 'horizontal' | 'both'
                    selectNodesRecursive: true,  //级联选择
                    //showCheckBoxesMode: 'selectAll', //Accepted Values: 'none' | 'normal' | 'selectAll'
                    noDataText: $translate.instant('NoDataText'),
                    onInitialized: function (e) {
                        $scope.permissionTreeViewInstance = e.component;
                        // $scope.widgetInstance.selectItem($scope.itemElement.id);
                    }
                };
            };

            var checkUserPermission = function () {

                var list = [];
                $scope.hasQueryPermission = false;
                $scope.hasAddPermission = false;
                $scope.hasEditPermission = false;

                $scope.hasUserQueryPermission = false;
                $scope.hasUserEditPermission = false;

                ////查看用户角色的权限
                //var tempUser = constant.adminPermission.infrastructure.userManage;
                //list.push(tempUser.queryCode);
                //list.push(tempUser.editCode);

                var temp = constant.adminPermission.infrastructure.organizationManage;
                list.push(temp.queryCode);
                list.push(temp.addCode);
                list.push(temp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasQueryPermission = data[temp.queryCode];
                    $scope.hasAddPermission = data[temp.addCode];
                    $scope.hasEditPermission = data[temp.editCode];

                    //$scope.hasUserQueryPermission = data[tempUser.queryCode];
                    //$scope.hasUserEditPermission = data[tempUser.editCode];

                    if ($scope.hasQueryPermission) {

                        initUserRoleUIGrid();
                        loadPermissionTree();
                        initOrg();
                        $timeout(function () {
                            getOrgList();
                        }, 200);
                        getAllRolePermission();

                    }

                });
            };

            // 初始化参数信息
            var initParams = function () {
                $scope.showRowLines = true;
                $scope.orgList = [];
                $scope.checkedOrgsSet = {};
                $scope.set = [];
                $scope.maxTitleLength = 10;
                $scope.maxValueLength = 20;
                $scope.selectCompany = {};
                $scope.showAttributeDimensionID = 'orgmanage';
                $scope.searchText = '';
                $scope.isCanOrganizationIsActiveBtn = true;
                $scope.currentNavItem = 'page1';
                $scope.userRoleList = "[]";

                $scope.taxReturnBusinessTypeList = constant.TaxReturnBusinessTypeList;
                $scope.trueFalse = constant.trueFalse;
                $scope.regFinancialAccountingTypeList = constant.RegFinancialAccountingTypeList;
                $scope.nationalEconomicIndustryList = constant.NationalEconomicIndustryList;
                $scope.applicableAccountingRuleList = constant.ApplicableAccountingRuleList;
                $scope.regStatusList = constant.RegStatusList;
                $scope.lowValueConsumablesAmortizationMethodList = constant.LowValueConsumablesAmortizationMethodList;
                $scope.depreciationMethodList = constant.DepreciationMethodList;
                $scope.taxCreditRatingList = constant.TaxCreditRatingList;
                $scope.architectureTypeList = constant.ArchitectureTypeList;
            };

            var loadDatagrid = function () {
                $scope.orgUserGridOptionsA = {
                    bindingOptions: {
                        dataSource: 'DataGridSource'
                    },
                    // height:700,
                    showBorders: true,
                    paging: {
                        pageSize: constant.page.logPageSize
                    },
                    pager: {
                        showPageSizeSelector: true,
                        allowedPageSizes: constant.page.pageSizeArrary,
                        showInfo: true
                    },
                    // export: {
                    //     enabled: false,
                    //     fileName: "机构信息列表"
                    // },
                    // columnChooser: {
                    //     enabled: true
                    // },
                    keyExpr: "name",
                    columns: [
                        {
                            dataField: "name",
                            caption: $translate.instant('OrganizationName'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    $('<a class="hyper-link">' + options.value + '</a>')
                                        .attr('href', 'javascript:void(0)')
                                        .on('click', function () {
                                            gotoOrg(options.row.data);
                                        })
                                        .appendTo(container);
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "code",
                            allowHeaderFiltering: false,
                            caption: $translate.instant('OrganizationCode')
                        },
                        {
                            dataField: "taxPayerNumber",
                            allowHeaderFiltering: true,
                            caption: $translate.instant('TaxPayerNumber')
                        },
                        {
                            dataField: "structureName",
                            caption: $translate.instant('OrganizationStructureDesc')
                        },
                        {
                            dataField: "regionName",
                            caption: $translate.instant('AreaRegionTitle'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessUnitName",
                            caption: $translate.instant('BusinessUnitTitleName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "areaName",
                            caption: $translate.instant('AreaTitleName'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "industryName",
                            caption: $translate.instant('PIndustry'),
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "isActive",
                            caption: $translate.instant('EnableStatus'),
                            allowHeaderFiltering: false,
                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.isActive) {
                                        $('<span>').text(translate.Enabled).appendTo(container);
                                    } else {
                                        $('<span style="color:gray">').text(translate.Disabled).appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "englishName",
                            caption: $translate.instant('OrganizationNameEn'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "abbreviation",
                            caption: $translate.instant('Abbreviation'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "foundationDate",
                            caption: $translate.instant('FoundationDate'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationLocation",
                            caption: $translate.instant('RegistrationLocation'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationLocationEn",
                            caption: $translate.instant('RegistrationLocationEn'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonName",
                            caption: $translate.instant('LegalPersonName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessScope",
                            caption: $translate.instant('BusinessScope'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regStatus",
                            caption: $translate.instant('RegStatus'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "architectureType",
                            caption: $translate.instant('ArchitectureType'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalEconomicIndustry",
                            caption: $translate.instant('NationalEconomicIndustry'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "engageNationalProhibitIndustry",
                            caption: $translate.instant('EngageNationalProhibitIndustry'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "registrationCapital",
                            caption: $translate.instant('RegistrationCapital'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "paidInCapital",
                            caption: $translate.instant('PaidInCapital'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "numOfBranches",
                            caption: $translate.instant('NumOfBranches'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "unifiedSocialCreditCode",
                            caption: $translate.instant('UnifiedSocialCreditCode'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialAccountingType",
                            caption: $translate.instant('RegFinancialAccountingType'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxRegStatus",
                            caption: $translate.instant('TaxRegStatus'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxCreditRating",
                            caption: $translate.instant('TaxCreditRating'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "applicableAccountingRule",
                            caption: $translate.instant('ApplicableAccountingRule'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "lowValueConsumablesAmortizationMethod",
                            caption: $translate.instant('LowValueConsumablesAmortizationMethod'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "depreciationMethod",
                            caption: $translate.instant('DepreciationMethod'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "accountingSoftware",
                            caption: $translate.instant('AccountingSoftware'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "completeRecordTotalInstitutions",
                            caption: $translate.instant('CompleteRecordTotalInstitutions'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonName",
                            caption: $translate.instant('TaxClientPersonName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonPhoneNum",
                            caption: $translate.instant('TaxClientPersonPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonIdNum",
                            caption: $translate.instant('TaxClientPersonIdNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "ticketHolderName",
                            caption: $translate.instant('TicketHolderName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "ticketHolderPhoneNum",
                            caption: $translate.instant('TicketHolderPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxHallAddress",
                            caption: $translate.instant('NationalTaxHallAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxAdministratorName",
                            caption: $translate.instant('NationalTaxAdministratorName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "nationalTaxAdministratorPhoneNum",
                            caption: $translate.instant('NationalTaxAdministratorPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxHallAddress",
                            caption: $translate.instant('LocalTaxHallAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxAdministratorName",
                            caption: $translate.instant('LocalTaxAdministratorName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "localTaxAdministratorPhoneNum",
                            caption: $translate.instant('LocalTaxAdministratorPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "etaWebsite",
                            caption: $translate.instant('EtaWebsite'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "signTripartiteAgreement",
                            caption: $translate.instant('SignTripartiteAgreement'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "reportingCurrency",
                            caption: $translate.instant('ReportingCurrency'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "consolidationTime",
                            caption: $translate.instant('ConsolidationTime'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "fiscalYearDeadline",
                            caption: $translate.instant('FiscalYearDeadline'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxAgent",
                            caption: $translate.instant('TaxAgent'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxAgentContact",
                            caption: $translate.instant('TaxAgentContact'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "otherFacts",
                            caption: $translate.instant('OtherFacts'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxReturnBusinessType",
                            caption: $translate.instant('TaxReturnBusinessType'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "smallMeagerProfit",
                            caption: $translate.instant('SmallMeagerProfit'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "listedCompany",
                            caption: $translate.instant('ListedCompany'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "applicableAccountingStandardsOrAccountingSystems",
                            caption: $translate.instant('ApplicableAccountingStandardsOrAccountingSystems'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxPayerNumberVat",
                            caption: $translate.instant('TaxPayerNumberVat'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxPayerNumberCit",
                            caption: $translate.instant('TaxPayerNumberCit'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxClientPersonEmailAddress",
                            caption: $translate.instant('TaxClientPersonEmailAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "bankAccountName",
                            caption: $translate.instant('BankAccountName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "bankAccountNumber",
                            caption: $translate.instant('BankAccountNumber'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonPhoneNumber",
                            caption: $translate.instant('LegalPersonPhoneNumber'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonLandlineNum",
                            caption: $translate.instant('LegalPersonLandlineNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "legalPersonEmailAddress",
                            caption: $translate.instant('LegalPersonEmailAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerName",
                            caption: $translate.instant('RegFinancialOfficerName'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerPhoneNum",
                            caption: $translate.instant('RegFinancialOfficerPhoneNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerLandlineNum",
                            caption: $translate.instant('RegFinancialOfficerLandlineNum'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "regFinancialOfficerEmailAddress",
                            caption: $translate.instant('RegFinancialOfficerEmailAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "actualBusinessAddress",
                            caption: $translate.instant('ActualBusinessAddress'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "secondaryApprovalAmount",
                            caption: $translate.instant('SecondaryApprovalAmount'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "businessRegistrationNumber",
                            caption: $translate.instant('BusinessRegistrationNumber'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "parValue",
                            caption: $translate.instant('ParValue'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "issuedShares",
                            caption: $translate.instant('IssuedShares'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "directors",
                            caption: $translate.instant('Directors'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "logoutTime",
                            caption: $translate.instant('LogoutTime'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "taxRuleIntroduction",
                            caption: $translate.instant('TaxRuleIntroduction'),
                            visible: false,
                            allowHeaderFiltering: false
                        },
                        {
                            dataField: "auditRequirements",
                            caption: $translate.instant('AuditRequirements'),
                            visible: false,
                            allowHeaderFiltering: false
                        }
                    ],
                    // masterDetail: {
                    //     enabled: false,
                    //     template: "detail"
                    // },
                    onContentReady: function (e) {
                        $scope.orgUserGridInstance = e.component;
                        // $scope.orgTreeList = e;
                        // $scope.orgTreeListInstance = e.component;
                        var totalCount = e.component.totalCount();
                        if (totalCount > 0) {
                            $scope.totalCount = totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    grouping: {
                        autoExpandAll: false
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    allowColumnReordering: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll')
                        }
                    }
                };

                // $scope.getDetailGridSettings = function (key) {
                //     return {
                //         //todo 绑定数据
                //         dataSource: new DevExpress.data.DataSource({
                //             load: function (loadOptions) {
                //                 var deferred = $q.defer();
                //                 return equityService.getEquityListResp(key.data.id).success(function (response) {
                //                     deferred.resolve({data: response, totalCount: response.length});
                //                 }).error(function () {
                //                     deferred.reject("Data Loading Error");
                //                 });
                //                 return deferred.promise;
                //             }
                //         }),
                //         columnAutoWidth: true,
                //         showBorders: true,
                //         columns: [
                //             {
                //                 dataField: "payableShareholderName",
                //                 width: "600px",
                //                 caption: $translate.instant('PayableShareholderName')
                //             },
                //             {
                //                 dataField: "payableContributionProportion",
                //                 width: "150px",
                //                 caption: $translate.instant('PayableContributionProportion')
                //             }]
                //     };
                // }

            };

            var gotoOrg = function (org) {
                $scope.showOrgs = false;
                console.log(org);
                $scope.selectCompany = org;
                $scope.showSingle = true;
            };

            $scope.showAll = function () {
                $scope.showOrgs = true;
                $scope.showSingle = false;
                $scope.selectCompany = {};
            };

            $scope.uploadAttach=function () {

            };

            (function initialize() {
                $log.debug('organizationManageController.ctor()...');
                //scope model
                $scope.title = $translate.instant('OrganizationManageTitle');
                initParams();
                //showUserTab();
                checkUserPermission();
                loadDatagrid();
                $scope.location = $scope.$root.isFront;
                $timeout(function () {
                    $scope.isLoadComplete = true;
                    if ($scope.location) {
                        $scope.showHeader = false;
                    }
                    else {
                        $scope.showHeader = true;
                    }
                }, 500);
            })();
        }
    ]);
