﻿systemConfigurationModule.controller('TaxCalendarConfigEditController', ['$scope', '$log', 'uiGridConstants', 'SweetAlert', '$translate',
    'stdAccountService', '$interval', 'orgService', '$timeout', '$q', 'commonWebService', 'loginContext',
    'userService', 'taxCalendarService', '$document','$uibModal','$state',
    function ($scope, $log, uiGridConstants, SweetAlert, $translate, stdAccountService, $interval, orgService,
        $timeout, $q, commonWebService, loginContext, userService, taxCalendarService, $document, $uibModal, $state) {
        'use strict';

        //初始化表单对象-->start
        //设置页面标题-->查看,新建,编辑日历设置
        $scope.PageTitle = ($scope.calendarConfigId ? ($scope.isReadOnly ? $translate.instant('View') : $translate.instant('Edit')) : $translate.instant('NewTaxCalendar')) + $translate.instant('TaxCalendarSet');
        $scope.bhOptions = {
            readOnly: true
        };
        $scope.companyOptions = {
            bindingOptions: {
                dataSource: 'orgList'
            },
            displayExpr: "companyName",
            valueExpr: "id",
            showSelectionControls: true,
            applyValueMode: "instantly",
            multiline: false,
            readOnly: !!$scope.isReadOnly,
            onValueChanged: function (e) {
                if (e && e.component) {
                    var datas = e.component.option('selectedItems');
                    if (datas && datas.length > 0) {
                        $scope.taxCalendarConfiguration.companyNames = _.pluck(datas, 'companyName').join(',');
                    }
                }
            },
            placeholder: $translate.instant('PleaseSelect')
        };
        $scope.taxOptions = {
            bindingOptions: {
                dataSource: 'taxProjectList',
                readOnly: 'isTaxProjectReadOnly'
            },
            displayExpr: "taxProjectName",
            valueExpr: "id",
            showSelectionControls: true,
            applyValueMode: "instantly",
            multiline: false,
            //readOnly: !!$scope.isReadOnly || !!$scope.calendarConfigId,
            onValueChanged: function (e) {
                if (e && e.component) {
                    var datas = e.component.option('selectedItems');
                    if (datas && datas.length > 0) {
                        $scope.taxCalendarConfiguration.taxProjectNames = _.pluck(datas, 'taxProjectName').join(',');
                    }
                }
            },
            placeholder: $translate.instant('PleaseSelect')
        };

        $scope.eventMonthOptions = {
            dataSource: [{ id: 1, month: $translate.instant('January') }, { id: 2, month: $translate.instant('February') }, { id: 3, month: $translate.instant('March') },
            { id: 4, month: $translate.instant('April') }, { id: 5, month: $translate.instant('May') }, { id: 6, month: $translate.instant('June') },
            { id: 7, month: $translate.instant('August') }, { id: 8, month: $translate.instant('July') }, { id: 9, month: $translate.instant('September') },
            { id: 10, month: $translate.instant('October') }, { id: 11, month: $translate.instant('November') }, { id: 12, month: $translate.instant('December') }],
            displayExpr: "month",
            valueExpr: "id",
            showSelectionControls: true,
            applyValueMode: "instantly",
            multiline: false,
            readOnly: !!$scope.isReadOnly,
            placeholder: $translate.instant('PleaseSelect')
        };
        $scope.eventDateOptions = {
            dataSource: [{ id: 1, day: '1'+$translate.instant('Day') }, { id: 2, day: '2'+$translate.instant('Day') }, { id: 3, day: '3'+$translate.instant('Day') }, { id: 4, day: '4'+$translate.instant('Day') }, { id: 5, day: '5'+$translate.instant('Day') }, { id: 6, day: '6'+$translate.instant('Day') },
            { id: 7, day: '7'+$translate.instant('Day') }, { id: 8, day: '8'+$translate.instant('Day') }, { id: 9, day: '9'+$translate.instant('Day') }, { id: 10, day: '10'+$translate.instant('Day') }, { id: 11, day: '11'+$translate.instant('Day') }, { id: 12, day: '12'+$translate.instant('Day') },
            { id: 13, day: '13'+$translate.instant('Day') }, { id: 14, day: '14'+$translate.instant('Day') }, { id: 15, day: '15'+$translate.instant('Day') }, { id: 16, day: '16'+$translate.instant('Day') }, { id: 17, day: '17'+$translate.instant('Day') }, { id: 18, day: '18'+$translate.instant('Day') },
            { id: 19, day: '19'+$translate.instant('Day') }, { id: 20, day: '20'+$translate.instant('Day') }, { id: 21, day: '21'+$translate.instant('Day') }, { id: 22, day: '22'+$translate.instant('Day') }, { id: 23, day: '23'+$translate.instant('Day') }, { id: 24, day: '24'+$translate.instant('Day') },
            { id: 25, day: '25'+$translate.instant('Day') }, { id: 26, day: '26'+$translate.instant('Day') }, { id: 27, day: '27'+$translate.instant('Day') }, { id: 28, day: '28'+$translate.instant('Day') }, { id: 29, day: '29'+$translate.instant('Day') }, { id: 30, day: '30'+$translate.instant('Day') },
            { id: 31, day: '31' + $translate.instant('Day') }, { id: 32, day: $translate.instant('TheLastDayOfMonth') }],
            displayExpr: "day",
            valueExpr: "id",
            showSelectionControls: true,
            applyValueMode: "instantly",
            multiline: false,
            readOnly: !!$scope.isReadOnly,
            placeholder: $translate.instant('PleaseSelect')
        };
        $scope.addressOptions = {
            bindingOptions: {
                dataSource: 'workPlaceList'
            },
            displayExpr: "name",
            valueExpr: "id",
            searchEnabled:true,
            showClearButton: true,
            readOnly: !!$scope.isReadOnly,
            onValueChanged: function (e) {
                if (e && e.component) {
                    var data = e.component.option('selectedItem');
                    if (data) {
                        $scope.taxCalendarConfiguration.workPlaceNames = data.name;
                    }
                }
            },
            placeholder: $translate.instant('PleaseSelect')
        };
        $scope.validDateStartOption = {
            readOnly: !!$scope.isReadOnly,
            placeholder: $translate.instant('PleaseSelect')
        };
        $scope.validDateEndOption = {
            readOnly: !!$scope.isReadOnly,
            placeholder: $translate.instant('PleaseSelect')
        };

        //办事人员
        $scope.operatorOptions = {
            bindingOptions:{
                dataSource: 'userList'
            },
            displayExpr: "userName",
            valueExpr: "id",
            showSelectionControls: true,
            applyValueMode: "instantly",
            multiline: false,
            readOnly: !!$scope.isReadOnly,
            onValueChanged: function (e) {
                if (e && e.component) {
                    var datas = e.component.option('selectedItems');
                    if (datas && datas.length > 0) {
                        $scope.taxCalendarConfiguration.operatorNames = _.pluck(datas, 'userName').join(',');
                    }
                }
            },
            placeholder: $translate.instant('PleaseSelect')
        };

        //相关人员
        $scope.notifierOptions = {
            bindingOptions: {
                dataSource: 'userList'
            },
            displayExpr: "userName",
            valueExpr: "id",
            showSelectionControls: true,
            applyValueMode: "instantly",
            multiline: false,
            readOnly: !!$scope.isReadOnly,
            onValueChanged: function (e) {
                if (e && e.component) {
                    var datas = e.component.option('selectedItems');
                    if (datas && datas.length > 0) {
                        $scope.taxCalendarConfiguration.notifierNames = _.pluck(datas, 'userName').join(',');
                    }
                }
            },
            placeholder: $translate.instant('PleaseSelect')
        };
        $scope.numberOptions = {};

        $scope.statusOptions = {
            dataSource: [{ value: 1, displayText: $translate.instant('Qiyong') }, { value: 0, displayText: $translate.instant('Jinyong') }],
            displayExpr: 'displayText',
            valueExpr: 'value',
            value: 1,
            layout: 'horizontal',
            readOnly: !!$scope.isReadOnly
        };

        $scope.isRelatedTaxMoneyOptions = {
            dataSource: [{ value: 1, displayText: $translate.instant('Shi') }, { value: 0, displayText: $translate.instant('Fou') }],
            displayExpr: 'displayText',
            valueExpr: 'value',
            value: 1,
            layout: 'horizontal',
            readOnly: !!$scope.isReadOnly
        };
        $scope.bzOptions = {
            readOnly: !!$scope.isReadOnly,
            placeholder: $translate.instant('PleaseInput'),
            height: 100,
            maxLength: 500,

        };
        //初始化表单对象-->end

        //表单验证对象初始化-->start
        $scope.validateOption = {};
        $scope.validateOption.validDateStartOption = {
            validationRules: [{
                type: "required",
                message: $translate.instant('ValidDataRequired')
            }]
        };
        $scope.validateOption.operatorOptions = {
            validationRules: [{
                type: "required",
                message: $translate.instant('OperaterRequired')
            }]
        };
        $scope.validateOption.companyOptions = {
            validationRules: [{
                type: "required",
                message: $translate.instant('CompanyRequired')
            }]
        };
        $scope.validateOption.eventMonthOptions = {
            validationRules: [{
                type: "required",
                message: $translate.instant('EventMonthRequired')
            }]
        };
        $scope.validateOption.taxOptions = {
            validationRules: [{
                type: "required",
                message: $translate.instant('TaxOptionRequired')
            }]
        };
        $scope.validateOption.eventDateOptions = {
            validationRules: [{
                type: "required",
                message: $translate.instant('EventDayRequired')
            }]
        };

        //表单验证对象初始化-->end

        $scope.editTaxProjectList = function () {
            if ($scope.isReadOnly) {
                return;
            }

            $scope.taxProjectGridOptions = {
                showRowLines: true,
                showColumnLines: true,
                showBorders: true,
                allowColumnResizing: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                bindingOptions: {
                    dataSource: 'taxProjectList'
                },
                filterRow: {
                    visible: true
                },
                height: 250,
                columns: [
                            { dataField: 'taxProjectName', caption: $translate.instant('TaxProjectName'), width: '70%' },
                            {
                                dataField: '', caption: $translate.instant('OrderOperation'), width: '30%', cellTemplate: function (ele, info) {
                                    $('<i class="fa fa-pencil-square-o"/>').css({ 'color': '#d00', 'cursor': 'pointer', 'font-size': '16px' }).html('&nbsp;&nbsp;').on('dxclick', function () {
                                        $scope.editTaxProject(info.data);
                                    }).appendTo(ele);
                                    //$('<i class="fa fa-trash"/>').css({ 'color': '#d00', 'cursor': 'pointer', 'font-size': '16px', 'padding-left': '10px' }).on('dxclick', function () {
                                    //    SweetAlert.swal({
                                    //        title: $translate.instant('DeleteConfirm'),
                                    //        text: $translate.instant('ComfirmDeleteData'),
                                    //        type: "warning",
                                    //        showCancelButton: true,
                                    //        confirmButtonColor: "#DD6B55",
                                    //        confirmButtonText: $translate.instant('Confirm'),
                                    //        cancelButtonText: $translate.instant('Cancel'),
                                    //        closeOnConfirm: true,
                                    //        closeOnCancel: true
                                    //    },
                                    //    function (isConfirm) {
                                    //        if (isConfirm) {
                                    //            taxCalendarService.deleteTaxProject(info.data.id).success(function () {
                                    //                SweetAlert.success($translate.instant('CommonSuccess'));
                                    //                refreshTaxProjectList();
                                    //                getCalendarConfigurationById();
                                    //            }).error(function () {

                                    //            });
                                    //        }
                                    //    });
                                    //}).appendTo(ele);
                                }
                            }
                ]
            };

            //关闭弹窗口
            $scope.hideEditTaxProjectListPanel = function () {
                $scope.editTaxProjectListInstance.dismiss('cancel');
            };

            $scope.editTaxProjectListInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'edit-tax-project-pop.html',
                windowClass: 'data-table',
                appendTo: angular.element($document[0].querySelector('#edit-tax-project-pop')),
                scope: $scope
            });
        };

        $scope.editTaxProject = function (data) {
            $scope.validateOption.taxProjectText = {
                validationRules: [{
                    type: "required",
                    message: $translate.instant('TaxProjectRequireWrite')
                }, {
                    type: "stringLength",
                    max: 200,
                    message: $translate.instant('TaxProjectMaxLength')
                }]
            };

            $scope.editTaxProjectEntity = {
                id: '',
                taxProjectName: ''
            };
            if (!data) {
                $scope.editTaxProjectTitle = $translate.instant('NewTaxProject');
            } else {
                $scope.editTaxProjectTitle = $translate.instant('EditTaxProject');
                $scope.editTaxProjectEntity.taxProjectName = data.taxProjectName;
                $scope.editTaxProjectEntity.id = data.id;
            }

            //保存税务事项
            $scope.confirmSubmitTaxProject = function () {
                //必填验证
                var dxResult = DevExpress.validationEngine.validateGroup($('#editTaxProjectForm').dxValidationGroup("instance")).isValid;
                if (!dxResult) {
                    return;
                }
                var taxProjectModel = $scope.editTaxProjectEntity;
                taxCalendarService.saveTaxProject(taxProjectModel).success(function (result) {
                    if (result == -1) {
                        SweetAlert.warning($translate.instant('TaxProjectNameRepeat'));
                    } else {
                        SweetAlert.success($translate.instant('CommonSuccess'));
                        $scope.editTaxProjectInstance.dismiss('cancel');
                        refreshTaxProjectList();
                        getCalendarConfigurationById();
                    }
                });
            };

            //关闭弹窗口
            $scope.hideEditTaxProjectPanel = function () {
                $scope.editTaxProjectInstance.dismiss('cancel');
            };

            $scope.editTaxProjectInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'edit-tax-project.html',
                windowClass: 'data-table',
                appendTo: angular.element($document[0].querySelector('#edit-tax-project')),
                scope: $scope
            });
        };

        $scope.editWorkPlaceList = function () {
            if ($scope.isReadOnly) {
                return;
            }

            $scope.workPlaceGridOptions = {
                showRowLines: true,
                showColumnLines: true,
                showBorders: true,
                allowColumnResizing: true,
                hoverStateEnabled: true,
                rowAlternationEnabled: true,
                bindingOptions: {
                    dataSource: 'workPlaceList'
                },
                filterRow: {
                    visible: true
                },
                height: 250,
                columns: [
                            { dataField: 'name', caption: $translate.instant('WorkPlaceName'), width: '70%' },
                            {
                                dataField: '', caption: $translate.instant('OrderOperation'), width: '30%', cellTemplate: function (ele, info) {
                                    $('<i class="fa fa-pencil-square-o"/>').css({ 'color': '#d00', 'cursor': 'pointer', 'font-size': '16px' }).html('&nbsp;&nbsp;').on('dxclick', function () {
                                        $scope.editWorkPlace(info.data);
                                    }).appendTo(ele);
                                    $('<i class="fa fa-trash"/>').css({ 'color': '#d00', 'cursor': 'pointer', 'font-size': '16px', 'padding-left': '10px' }).on('dxclick', function () {
                                        SweetAlert.swal({
                                            title: $translate.instant('DeleteConfirm'),
                                            text: $translate.instant('ComfirmDeleteData'),
                                            type: "warning",
                                            showCancelButton: true,
                                            confirmButtonColor: "#DD6B55",
                                            confirmButtonText: $translate.instant('Confirm'),
                                            cancelButtonText: $translate.instant('Cancel'),
                                            closeOnConfirm: true,
                                            closeOnCancel: true
                                        },
                                        function (isConfirm) {
                                            if (isConfirm) {
                                                taxCalendarService.deleteWorkPlace(info.data.id).success(function () {
                                                    SweetAlert.success($translate.instant('CommonSuccess'));
                                                    refreshWorkPlaceList();
                                                    getCalendarConfigurationById();
                                                }).error(function () {

                                                });
                                            }
                                        });
                                    }).appendTo(ele);
                                }
                            }
                ]
            };

            //关闭弹窗口
            $scope.hideEditWorkPlaceListPanel = function () {
                $scope.editWorkPlaceListInstance.dismiss('cancel');
            };

            $scope.editWorkPlaceListInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'edit-work-place-pop.html',
                windowClass: 'data-table',
                appendTo: angular.element($document[0].querySelector('#edit-work-place-pop')),
                scope: $scope
            });
        };

        $scope.editWorkPlace = function (data) {
            $scope.validateOption.workPlaceText = {
                validationRules: [{
                    type: "required",
                    message: $translate.instant('WorkPlaceRequireWrite')
                }, {
                    type: "stringLength",
                    max: 200,
                    message: $translate.instant('WorkPlaceMaxLength')
                }]
            };
            $scope.editWorkPlaceEntity = {
                id: '',
                name: ''
            };

            if (!data) {
                $scope.editWorkPlaceTitle = $translate.instant('NewWorkPlace');
            } else {
                $scope.editWorkPlaceTitle = $translate.instant('EditWorkPlace');
                $scope.editWorkPlaceEntity.id = data.id;
                $scope.editWorkPlaceEntity.name = data.name;
            }

            //关闭弹窗口
            $scope.hideEditWorkPlacePanel = function () {
                $scope.editWorkPlaceInstance.dismiss('cancel');
            };

            //保存办事地点
            $scope.confirmSubmitWorkPlace = function () {
                //必填验证
                var dxResult = DevExpress.validationEngine.validateGroup($('#editWorkPlaceForm').dxValidationGroup("instance")).isValid;
                if (!dxResult) {
                    return;
                }
                var workPlaceModel = $scope.editWorkPlaceEntity;
                taxCalendarService.saveWorkPlace(workPlaceModel).success(function (result) {
                    if (result == -1) {
                        SweetAlert.warning($translate.instant('WorkPlaceNameRepeat'));
                    } else {
                        SweetAlert.success($translate.instant('CommonSuccess'));
                        $scope.editWorkPlaceInstance.dismiss('cancel');
                        refreshWorkPlaceList();
                        getCalendarConfigurationById();
                    }

                });
            };

            $scope.editWorkPlaceInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'edit-work-place.html',
                windowClass: 'data-table',
                appendTo: angular.element($document[0].querySelector('#edit-work-place')),
                scope: $scope
            });
        };

        var refreshTaxProjectList = function() {
            taxCalendarService.getTaxProjectList().success(function (result) {
                if (result) {
                    $scope.taxProjectList = result;
                }
                resetEditBoxTag();
            });
        };

        var refreshWorkPlaceList = function () {
            taxCalendarService.getWorkPlaceList().success(function (result) {
                if (result) {
                    $scope.workPlaceList = result;
                }
                resetEditBoxTag();
            });
        };

        var getCalendarConfigurationById = function () {
            if ($scope.calendarConfigId) {
                taxCalendarService.getTaxCalendarConfigurationByID($scope.calendarConfigId).success(function (result) {
                    if (result) {
                        $scope.taxCalendarConfiguration = result;
                        $scope.taxCalendarConfiguration.companyArr = result.companyIDs ? result.companyIDs.split(',') : null;
                        $scope.taxCalendarConfiguration.monthArr = result.projectMonths ? result.projectMonths.split(',') : null;
                        $scope.taxCalendarConfiguration.taxProjectIdArr = result.taxProjectIDs ? result.taxProjectIDs.split(',') : null;
                        $scope.taxCalendarConfiguration.projectDayArr = result.projectDays ? result.projectDays.split(',') : null;
                        $scope.taxCalendarConfiguration.operatorIdArr = result.operatorIDs ? result.operatorIDs.split(',') : null;
                        $scope.taxCalendarConfiguration.notifierIdArr = result.notifierIDs ? result.notifierIDs.split(',') : null;

                        if ($scope.taxCalendarConfiguration.monthArr) {
                            $scope.taxCalendarConfiguration.monthArr = _.map($scope.taxCalendarConfiguration.monthArr, function (item) { return item * 1; });
                        }
                        if ($scope.taxCalendarConfiguration.projectDayArr) {
                            $scope.taxCalendarConfiguration.projectDayArr = _.map($scope.taxCalendarConfiguration.projectDayArr, function (item) { return item * 1; });
                        }
                    }
                    resetEditBoxTag();
                });
            }
        };

        var getMaxNumber = function () {
            if (!$scope.calendarConfigId) {
                taxCalendarService.getMaxNumber().success(function (data) {
                    $scope.taxCalendarConfiguration.calendarNumber = data;
                }).error(function () {

                });
            }
        };

        //保存配置-->start
        var startSaveConfig = function (model, flag) {
            model.companyIDs = "";
            model.projectMonths = "";
            model.taxProjectIDs = "";
            model.projectDays = "";
            model.operatorIDs = "";
            model.notifierIDs = "";
            if (model.companyArr && model.companyArr.length > 0) {
                model.companyIDs = model.companyArr.join(',');
            }
            
            if (model.monthArr && model.monthArr.length > 0) {
                model.monthArr = _.sortBy(model.monthArr, function (month) { return month; });
                model.projectMonths = model.monthArr.join(',');
            }
            
            if (model.taxProjectIdArr && model.taxProjectIdArr.length > 0) {
                model.taxProjectIDs = model.taxProjectIdArr.join(',');
            }
            
            if (model.projectDayArr && model.projectDayArr.length > 0) {
                model.projectDayArr = _.sortBy(model.projectDayArr, function (day) { return day; });
                model.projectDays = model.projectDayArr.join(',');
            }
            
            if (model.operatorIdArr && model.operatorIdArr.length > 0) {
                model.operatorIDs = model.operatorIdArr.join(',');
            }
            
            if (model.notifierIdArr && model.notifierIdArr.length > 0) {
                model.notifierIDs = model.notifierIdArr.join(',');
            }
            if (flag == 2) {
                model.id = null;
            }
            taxCalendarService.saveTaxCalendarConfig(model).success(function () {
                SweetAlert.success($translate.instant('CommonSuccess'));
                $scope.backToListPage();
            }).error(function () {

            });
        }

        //用户公司访问权限检查结果表格
        $scope.userPromissCheckOptions = {
            columns: [
                { dataField: 'userName', caption: '用户名称' },
                {dataField: 'companyName', caption: '公司名称'}
            ],
            showRowLines: true,
            showColumnLines: true,
            showBorders: true,
            allowColumnResizing: true,
            columnAutoWidth: true,
            allowColumnReordering: true,
            height: 200,
            columnFixing: {
                enabled: true
            },
            bindingOptions: {
                dataSource: 'noPromissUserList'
            }
        };

        $scope.noPromissUserList = [];
        $scope.saveConfig = function (flag) {
            $scope.noPromissUserList = [];
            //必填验证
            var dxResult = DevExpress.validationEngine.validateGroup($('#taxCalendarConfigForm').dxValidationGroup("instance")).isValid;
            if (!dxResult) {
                return;
            }
            var model = $scope.taxCalendarConfiguration;
            //检查选择的公司与员工的可访问权限是否匹配
            var checkDto = {};
            checkDto.companyList = model.companyArr;
            checkDto.userList = _.union(model.operatorIdArr, model.notifierIdArr);
            taxCalendarService.checkUserCompanyPromiss(checkDto).success(function (result) {
                if (result && result.length > 0) {
                    $scope.noPromissUserList = result;
                    //关闭弹窗口
                    $scope.hideUserPromissCheckPanel = function () {
                        $scope.userPromissInstance.dismiss('cancel');
                    };

                    $scope.userPromissInstance = $uibModal.open({
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',
                        templateUrl: 'user-promiss-check.html',
                        windowClass: 'data-table',
                        appendTo: angular.element($document[0].querySelector('#user-promiss-check-container')),
                        scope: $scope
                    });
                } else {
                    startSaveConfig(model, flag);
                }
            });
        };
        //保存配置-->end

        //日历设置另存为
        $scope.saveAsConfig = function () {
            $scope.calendarConfigId = null;
            $scope.PageTitle = $translate.instant('NewTaxCalendar') + $translate.instant('TaxCalendarSet');
            $scope.isTaxProjectReadOnly = false;
            $scope.taxCalendarConfiguration.id = null;
            getMaxNumber();
        };

        $scope.backToListPage = function () {
            $state.go('taxCalendarConfiguration');
        };

        //默认启用和涉及税款
        $scope.taxCalendarConfiguration = {
            status: 1,
            isRelatedTaxMoney: 0
        };

        //tagBox控件不可编辑时，隐藏X按钮
        var resetEditBoxTag = function () {
            $timeout(function () {
                if (!!$scope.isReadOnly) {
                    $('.dx-tag-remove-button').hide();
                    $('.dx-tag-content').css('padding-right', '6px');
                }

                if (!!$scope.calendarConfigId) {
                    $('#tax-project .dx-tag-remove-button').hide();
                    $('#tax-project .dx-tag-content').css('padding-right', '6px');
                }
            }, 50);
        };

        (function () {
            $scope.userList = [];
            $scope.orgList = [];
            $scope.workPlaceList = [];
            $scope.isTaxProjectReadOnly = !!$scope.isReadOnly || !!$scope.calendarConfigId;
            userService.getAllAvalideUserList().success(function (result) {
                if (result) {
                    $scope.userList = _.map(result, function (item) {
                        var obj = { id: item.id, userName: item.userName };
                        return obj;
                    });
                }
            });

            orgService.getAllActiveOrgList().success(function (result) {
                $scope.orgList = _.map(result, function (item) {
                    var obj = { id: item.id, companyName: item.name };
                    return obj;
                });
            });

            refreshWorkPlaceList();

            refreshTaxProjectList();

            getCalendarConfigurationById();

            getMaxNumber();
        })();
    }]);