﻿taxCalendarModule.controller('calendarDisplayController', ['$rootScope', '$scope', '$timeout', '$q', '$log', '$translate', '$state', 'SweetAlert', 'taxCalendarService', 'loginContext', 'userService', 'ackMessageBox',
    function ($rootScope, $scope, $timeout, $q, $log, $translate, $state, SweetAlert, taxCalendarService, loginContext, userService, ackMessageBox) {
        'use strict';
        $log.debug('calendarDisplayController.ctor()...');

        var scheduleDataSourceList = [];

        var taxProjectList = [];

        $scope.vatPermission = constant.vatPermission;


        //全局变量初始化放顶上
        var CompanyList = [];
        var CalendarList = [];
        var dataOptions = {

            colorArray: [
                {
                    color: '#ffffff',
                    bgColor: '#e0301e',
                    dragBgColor: '#e0301e',
                    borderColor: '#e0301e'
                },
                {
                    color: '#ffffff',
                    bgColor: '#d93954',
                    dragBgColor: '#d93954',
                    borderColor: '#d93954'
                },
                {
                    color: '#ffffff',
                    bgColor: '#fd6412',
                    dragBgColor: '#fd6412',
                    borderColor: '#fd6412'
                },
                {
                    color: '#ffffff',
                    bgColor: '#ffbf1f',
                    dragBgColor: '#ffbf1f',
                    borderColor: '#ffbf1f'
                },
                {
                    color: '#ffffff',
                    bgColor: '#968c6d',
                    dragBgColor: '#968c6d',
                    borderColor: '#968c6d'
                },
                {
                    color: '#ffffff',
                    bgColor: '#741910',
                    dragBgColor: '#741910',
                    borderColor: '#741910'
                },
                {
                    color: '#ffffff',
                    bgColor: '#94cf97',
                    dragBgColor: '#94cf97',
                    borderColor: '#94cf97'
                },
                {
                    color: '#ffffff',
                    bgColor: '#38963c',
                    dragBgColor: '#38963c',
                    borderColor: '#38963c'
                },
                {
                    color: '#ffffff',
                    bgColor: '#eea8b6',
                    dragBgColor: '#eea8b6',
                    borderColor: '#eea8b6'
                },
                {
                    color: '#ffffff',
                    bgColor: '#f5924d',
                    dragBgColor: '#f5924d',
                    borderColor: '#f5924d'
                },
                {
                    color: '#ffffff',
                    bgColor: '#cc7a00',
                    dragBgColor: '#cc7a00',
                    borderColor: '#cc7a00'
                },
                {
                    color: '#ffffff',
                    bgColor: '#ffdc85',
                    dragBgColor: '#ffdc85',
                    borderColor: '#ffdc85'
                },
                {
                    color: '#ffffff',
                    bgColor: '#8f1f13',
                    dragBgColor: '#8f1f13',
                    borderColor: '#8f1f13'
                },
                {
                    color: '#ffffff',
                    bgColor: '#bd2525',
                    dragBgColor: '#bd2525',
                    borderColor: '#bd2525'
                },
                {
                    color: '#ffffff',
                    bgColor: '#855f00',
                    dragBgColor: '#855f00',
                    borderColor: '#855f00'
                },
                {
                    color: '#ffffff',
                    bgColor: '#d8d8d8',
                    dragBgColor: '#d8d8d8',
                    borderColor: '#d8d8d8'
                },
                {
                    color: '#ffffff',
                    bgColor: '#ffe8dc',
                    dragBgColor: '#ffe8dc',
                    borderColor: '#ffe8dc'
                },
                {
                    color: '#ffffff',
                    bgColor: '#fae5e9',
                    dragBgColor: '#fae5e9',
                    borderColor: '#fae5e9'
                },
                {
                    color: '#ffffff',
                    bgColor: '#feb791',
                    dragBgColor: '#feb791',
                    borderColor: '#feb791'
                },
                {
                    color: '#ffffff',
                    bgColor: '#ffecbd',
                    dragBgColor: '#ffecbd',
                    borderColor: '#ffecbd'
                },
                {
                    color: '#ffffff',
                    bgColor: '#ebe9e4',
                    dragBgColor: '#ebe9e4',
                    borderColor: '#ebe9e4'
                },
                {
                    color: '#ffffff',
                    bgColor: '#e2aaa7',
                    dragBgColor: '#e2aaa7',
                    borderColor: '#e2aaa7'
                },
                {
                    color: '#ffffff',
                    bgColor: '#c2e4e2',
                    dragBgColor: '#c2e4e2',
                    borderColor: '#c2e4e2'
                },
                {
                    color: '#ffffff',
                    bgColor: '#d1ebd2',
                    dragBgColor: '#d1ebd2',
                    borderColor: '#d1ebd2'
                },
                {
                    color: '#ffffff',
                    bgColor: '#f09b92',
                    dragBgColor: '#f09b92',
                    borderColor: '#f09b92'
                },
                {
                    color: '#ffffff',
                    bgColor: '#c14a44',
                    dragBgColor: '#c14a44',
                    borderColor: '#c14a44'
                },
                {
                    color: '#ffffff',
                    bgColor: '#d04a02',
                    dragBgColor: '#d04a02',
                    borderColor: '#d04a02'
                },
                {
                    color: '#ffffff',
                    bgColor: '#e0a000',
                    dragBgColor: '#e0a000',
                    borderColor: '#e0a000'
                },
                {
                    color: '#ffffff',
                    bgColor: '#4f4a39',
                    dragBgColor: '#4f4a39',
                    borderColor: '#4f4a39'
                },
                {
                    color: '#ffffff',
                    bgColor: '#491b18',
                    dragBgColor: '#491b18',
                    borderColor: '#491b18'
                },
                {
                    color: '#ffffff',
                    bgColor: '#39d958',
                    dragBgColor: '#39d958',
                    borderColor: '#39d958'
                },
                {
                    color: '#ffffff',
                    bgColor: '#006652',
                    dragBgColor: '#006652',
                    borderColor: '#006652'
                },
                {
                    color: '#ffffff',
                    bgColor: '#714300',
                    dragBgColor: '#714300',
                    borderColor: '#714300'
                },
                {
                    color: '#ffffff',
                    bgColor: '#615a46',
                    dragBgColor: '#615a46',
                    borderColor: '#615a46'
                },
                {
                    color: '#ffffff',
                    bgColor: '#de536f',
                    dragBgColor: '#de536f',
                    borderColor: '#de536f'
                },
                {
                    color: '#ffffff',
                    bgColor: '#b23f02',
                    dragBgColor: '#b23f02',
                    borderColor: '#b23f02'
                }
            ],

            statusList: [{ name: '未完成', value: 0, checked: true }, { name: '已完成', value: 1, checked: true }],
            calendarTypeList: [{ name: '我的事项', value: true, checked: true }, { name: '他人事项', value: false, checked: true }],
            allScheduleList: [],

            recogizeStatus: {
                failure: 0,
                RecongizeSuccessExaminationFailed: 1,
                sucess: 2
            }
        };

        //全部scope变量初始化
        var initScopeVariable = function () {

            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
            };

            //页面搜索对象
            $scope.searchEntity = {};

            //翻译放在顶上
            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
            };

            //弹框服务
            $scope.modalService = {
                //打开发票认证模态框
                invoiceVerify: {
                    open: function () {
                        $scope.verifyInvoiceModalInstance = ackUibModal($scope, 'uploadInvoiceVerify.html', 'importVerifyInvoiceModal', '.invoice-manage-main', 'static');
                        $scope.verifyInvoiceModalInstance.open();
                    },
                    save: function () {
                        //logic here
                        $scope.verifyInvoiceModalInstance.close();
                    },
                    cancel: function () {
                        $scope.verifyInvoiceModalInstance.cancel();
                    },
                },
            };
        };


        var initCalendar = function () {
            'use strict';

            /* eslint-disable require-jsdoc */
            /* eslint-env jquery */
            /* global moment, tui, chance */
            /* global findCalendar, CalendarList, ScheduleList, generateSchedule */

            (function (window, Calendar) {
                var cal, resizeThrottled;
                var useCreationPopup = false;
                var useDetailPopup = false;
                var datePicker, selectedCalendar;

                cal = new Calendar('#calendar', {
                    defaultView: 'month',
                    useCreationPopup: useCreationPopup,
                    useDetailPopup: false,
                    calendars: CalendarList,
                    month: {
                        narrowWeekend: false,
                        startDayOfWeek: 1,
                        workweek: false
                    },
                    week:{
                        narrowWeekend: false,
                        startDayOfWeek: 1,
                        workweek: false
                    },
                    template: {
                        milestone: function (model) {//calendar-font-icon ic-milestone-b
                            return '<span class="calendar-font-icon ic-milestone-b"></span> <span style="background-color: ' + model.bgColor + '">' + model.title + '</span>';
                        },
                        allday: function (schedule) {
                            return getTimeTemplate(schedule, true);
                        },
                        time: function (schedule) {
                            return getTimeTemplate(schedule, false);
                        }
                    }
                });

                // event handlers
                cal.on({
                    'clickSchedule': function (e) {
                        console.log('clickSchedule', e);

                        showDetailPopUp(e);

                    },
                    'clickDayname': function (date) {
                        console.log('clickDayname', date);
                    },
                    'beforeCreateSchedule': function (e) {
                        console.log('beforeCreateSchedule', e);
                        // saveNewSchedule(e);
                        var guide = e.guide;
                        // use guideEl$'s left, top to locate your schedule creation popup
                        createNewScheduleClick(e);
                        // after that call this to hide the creation guide
                        guide.clearGuideElement(e);

                    },
                    'beforeUpdateSchedule': function (e) {
                        console.log('beforeUpdateSchedule', e);
                        e.schedule.start = e.start;
                        e.schedule.end = e.end;
                        cal.updateSchedule(e.schedule.id, e.schedule.calendarId, e.schedule);
                    },
                    'beforeDeleteSchedule': function (e) {
                        console.log('beforeDeleteSchedule', e);
                        cal.deleteSchedule(e.schedule.id, e.schedule.calendarId);
                    },
                    'afterRenderSchedule': function (e) {
                        var schedule = e.schedule;
                        // var element = cal.getElement(schedule.id, schedule.calendarId);
                        // console.log('afterRenderSchedule', element);
                    }
                });

                /**
                 * Get time template for time and all-day
                 * @param {Schedule} schedule - schedule
                 * @param {boolean} isAllDay - isAllDay or hasMultiDates
                 * @returns {string}
                 */
                function getTimeTemplate(schedule, isAllDay) {
                    var html = [];
                    //var start = moment(schedule.start.toUTCString());
                    //if (!isAllDay) {
                    //    html.push('<strong>' + start.format('HH:mm') + '</strong> ');
                    //}
                    if (schedule.isPrivate) {
                        html.push('<span class="calendar-font-icon ic-lock-b"></span>');
                        html.push(' Private');
                    } else {
                        html.push(schedule.title + ' ');
                        if (schedule.raw && schedule.raw.fileList && schedule.raw.fileList.length > 0) {
                            html.push('<span style="transform: rotate(90deg);" class="fa fa-paperclip"></span>');
                        }
                        //if (schedule.isReadOnly) {
                        //    html.push('<span class="calendar-font-icon ic-readonly-b"></span>');
                        //} else if (schedule.recurrenceRule) {
                        //    html.push('<span class="calendar-font-icon ic-repeat-b"></span>');
                        //} else if (schedule.attendees.length) {
                        //    html.push('<span class="calendar-font-icon ic-user-b"></span>');
                        //} else if (schedule.location) {
                        //    html.push('<span class="fa fa-paperclip"></span>');
                        //}
                        
                    }

                    return html.join('');
                }

                /**
                 * A listener for click the menu
                 * @param {Event} e - click event
                 */
                function onClickMenu(e) {
                    var target = $(e.target).closest('a[role="menuitem"]')[0];
                    var action = getDataAction(target);
                    var options = cal.getOptions();
                    var viewName = '';

                    console.log(target);
                    console.log(action);
                    switch (action) {
                        case 'toggle-daily':
                            viewName = 'day';
                            break;
                        case 'toggle-weekly':
                            viewName = 'week';
                            break;
                        case 'toggle-monthly':
                            options.month.visibleWeeksCount = 0;
                            viewName = 'month';
                            break;
                        case 'toggle-weeks2':
                            options.month.visibleWeeksCount = 2;
                            viewName = 'month';
                            break;
                        case 'toggle-weeks3':
                            options.month.visibleWeeksCount = 3;
                            viewName = 'month';
                            break;
                        case 'toggle-narrow-weekend':
                            options.month.narrowWeekend = !options.month.narrowWeekend;
                            options.week.narrowWeekend = !options.week.narrowWeekend;
                            viewName = cal.getViewName();

                            target.querySelector('input').checked = options.month.narrowWeekend;
                            break;
                        case 'toggle-start-day-1':
                            options.month.startDayOfWeek = options.month.startDayOfWeek ? 0 : 1;
                            options.week.startDayOfWeek = options.week.startDayOfWeek ? 0 : 1;
                            viewName = cal.getViewName();

                            target.querySelector('input').checked = options.month.startDayOfWeek;
                            break;
                        case 'toggle-workweek':
                            options.month.workweek = !options.month.workweek;
                            options.week.workweek = !options.week.workweek;
                            viewName = cal.getViewName();

                            target.querySelector('input').checked = !options.month.workweek;
                            break;
                        default:
                            break;
                    }

                    cal.setOptions(options, true);
                    cal.changeView(viewName, true);

                    setDropdownCalendarType();
                    setRenderRangeText();
                    setSchedules();
                    // 关闭弹出层
                    $scope.popupOptions.operateType = constant.Operation.Close;
                }

                function onClickNavi(e) {
                    var action = getDataAction(e.target);

                    switch (action) {
                        case 'move-prev':
                            cal.prev();
                            break;
                        case 'move-next':
                            cal.next();
                            break;
                        case 'move-today':
                            cal.today();
                            break;
                        default:
                            return;
                    }

                    setRenderRangeText();
                    setSchedules();
                    // 关闭弹出层
                    $scope.popupOptions.operateType = constant.Operation.Close;
                }

                function onNewSchedule() {
                    var title = $('#new-schedule-title').val();
                    var location = $('#new-schedule-location').val();
                    var isAllDay = document.getElementById('new-schedule-allday').checked;
                    var start = datePicker.getStartDate();
                    var end = datePicker.getEndDate();
                    var calendar = selectedCalendar ? selectedCalendar : CalendarList[0];

                    if (!title) {
                        return;
                    }

                    cal.createSchedules([{
                        id: String(chance.guid()),
                        calendarId: calendar.id,
                        title: title,
                        isAllDay: isAllDay,
                        start: start,
                        end: end,
                        category: isAllDay ? 'allday' : 'time',
                        dueDateClass: '',
                        color: calendar.color,
                        bgColor: calendar.bgColor,
                        dragBgColor: calendar.bgColor,
                        borderColor: calendar.borderColor,
                        raw: {
                            location: location
                        },
                        state: 'Busy'
                    }]);

                    $('#modal-new-schedule').modal('hide');
                }

                function onChangeNewScheduleCalendar(e) {
                    var target = $(e.target).closest('a[role="menuitem"]')[0];
                    var calendarId = getDataAction(target);
                    changeNewScheduleCalendar(calendarId);
                }

                function changeNewScheduleCalendar(calendarId) {
                    var calendarNameElement = document.getElementById('calendarName');
                    var calendar = findCalendar(calendarId);
                    var html = [];

                    html.push('<span class="calendar-bar" style="background-color: ' + calendar.bgColor + '; border-color:' + calendar.borderColor + ';"></span>');
                    html.push('<span class="calendar-name">' + calendar.name + '</span>');

                    calendarNameElement.innerHTML = html.join('');

                    selectedCalendar = calendar;
                }

                // 点击新建 schedule 的事件
                function createNewSchedule(event) {
                    //var start = event.start ? new Date(event.start.getTime()) : new Date();
                    //var end = event.end ? new Date(event.end.getTime()) : moment().add(1, 'hours').toDate();

                    var start = event.start;

                    if (!start) {
                        if ($('.tui-full-calendar-today').length != 0) {
                            start = new Date();
                        } else {
                            if (window.cal._viewName === 'week') {
                                start = new Date(window.cal._renderRange.start);
                            } else {
                                start = new Date(window.cal._renderRange.start);
                            }
                        }
                    }

                    var userDefine = getUserDefineTaxProject();

                    if (!userDefine) {
                        SweetAlert.warning($translate.instant('UserDefineNotInTaxProjectName'));
                        return;
                    };

                    $scope.popupOptions.operateModel = {
                        operatorNames: loginContext.userName,
                        type: 1,
                        companyID: '',
                        companyName: '',
                        operatorIDs: loginContext.userId,
                        eventDate: start,
                        status: 0,
                        btnCreate: true,
                        taxProjectID: userDefine.id,
                        taxProjectName: userDefine.taxProjectName,
                        colorGroup: userDefine.colorGroup
                    };

                    $scope.popupOptions.operateType = constant.Operation.Add;
                }
                function saveNewSchedule(scheduleData) {
                    var calendar = scheduleData.calendar || findCalendar(scheduleData.calendarId);
                    var schedule = {
                        id: String(chance.guid()),
                        title: scheduleData.title,
                        isAllDay: scheduleData.isAllDay,
                        start: scheduleData.start,
                        end: scheduleData.end,
                        category: scheduleData.isAllDay ? 'allday' : 'time',
                        dueDateClass: '',
                        color: calendar.color,
                        bgColor: calendar.bgColor,
                        dragBgColor: calendar.bgColor,
                        borderColor: calendar.borderColor,
                        raw: {
                            'class': scheduleData.raw['class'],
                            location: scheduleData.raw.location
                        },
                        state: scheduleData.state
                    };
                    if (calendar) {
                        schedule.calendarId = calendar.id;
                        schedule.color = calendar.color;
                        schedule.bgColor = calendar.bgColor;
                        schedule.borderColor = calendar.borderColor;
                    }

                    cal.createSchedules([schedule]);

                    refreshScheduleVisibility();
                }

                //更新属性选中状态并刷新数据
                function filterScheduleProperty(propertyList, propertyTypeId, propertyName, sourceScheduleList) {
                    var elements = Array.prototype.slice.call(document.querySelectorAll('#' + propertyTypeId + ' input'));
                    var propertyIds = [];
                    elements.forEach(function (input) {
                        var span = input.nextSibling;
                        if (input.checked) {
                            propertyIds.push(input.value);
                            if (span.style.borderColor != "rgb(170, 170, 170)") {
                                span.style.backgroundColor = span.style.borderColor;
                            } else {
                                if (span.className != 'fa fa-check') {
                                    $(span).addClass('fa').addClass('fa-check');
                                    
                                }
                            }
                        } else {
                            if (span.style.borderColor != "rgb(170, 170, 170)") {
                                span.style.backgroundColor = 'transparent';
                            } else {
                                $(span).removeClass('fa').removeClass('fa-check');
                            }
                        }
                    });

                    var resultScheduleList = _.filter(sourceScheduleList, function (schedule) {
                        return _.contains(propertyIds, schedule[propertyName]);
                    });

                    return resultScheduleList;
                }

                //刷新筛选选择
                function refreshFilterChoise() {
                    //链式传递筛选结果
                    var cScheduleList = filterScheduleProperty(CompanyList, 'companyList', 'companyID', dataOptions.allScheduleList);
                    var sScheduleList = filterScheduleProperty(dataOptions.statusList, 'statusList', 'status', cScheduleList);
                    ScheduleList = filterScheduleProperty(dataOptions.calendarTypeList, 'calendarTypeList', 'calendarType', sScheduleList);
                    refreshSchedule();
                }

                function onChangeCalendars(e) {
                    var calendarId = e.target.value;
                    var checked = e.target.checked;
                    var viewAll = document.querySelector('.lnb-calendars-item input');
                    var calendarElements = Array.prototype.slice.call(document.querySelectorAll('#calendarList input,#companyList input,#statusList input,#calendarTypeList input'));
                    var allCheckedCalendars = true;
                    var allSpan = e.target.nextElementSibling;

                    if (calendarId === 'all') {
                        
                        allCheckedCalendars = checked;
                        
                        if (checked && allSpan.className != 'fa fa-check') {
                            $(allSpan).addClass('fa').addClass('fa-check');
                        } else if (!checked) {
                            $(allSpan).removeClass('fa').removeClass('fa-check');
                        }

                        calendarElements.forEach(function (input) {
                            var span = input.parentNode;
                            input.checked = checked;
                            if (span.style.borderColor != "rgb(170, 170, 170)") {
                                span.style.backgroundColor = checked ? span.style.borderColor : 'transparent';
                            }
                            //span.style.backgroundColor = checked ? span.style.borderColor : 'transparent';
                        });

                        CalendarList.forEach(function (calendar) {
                            calendar.checked = checked;
                        });

                        CompanyList.forEach(function (calendar) {
                            calendar.checked = checked;
                        });

                        refreshFilterChoise();

                    } else {
                        allSpan = viewAll.nextElementSibling;
                        var eleType = $(e.target).attr("eleType");
                        if (eleType) {
                            refreshFilterChoise();
                        }
                        else {
                            //设置状态
                            _.filter(CalendarList, function (ca) { return ca.id === calendarId })[0].checked = checked;
                        }

                        allCheckedCalendars = calendarElements.every(function (input) {
                            return input.checked;
                        });

                        if (allCheckedCalendars) {
                            viewAll.checked = true;
                            if (allSpan.className != 'fa fa-check') {
                                $(allSpan).addClass('fa').addClass('fa-check');
                            }
                        } else {
                            viewAll.checked = false;
                            $(allSpan).removeClass('fa').removeClass('fa-check');
                        }
                    }

                    refreshScheduleVisibility();
                }

                function refreshScheduleVisibility() {
                    var calendarElements = Array.prototype.slice.call(document.querySelectorAll('#calendarList input'));

                    CalendarList.forEach(function (calendar) {
                        cal.toggleSchedules(calendar.id, !calendar.checked, false);
                    });

                    cal.render(true);

                    calendarElements.forEach(function (input) {
                        var span = input.nextElementSibling;
                        if (span.style.borderColor != "rgb(170, 170, 170)") {
                            span.style.backgroundColor = span.style.borderColor;
                            span.style.color = "rgb(255, 255, 255)";
                            span.style.lineHeight = "9px";
                            span.style.paddingLeft = "2px";
                            span.style.fontSize = "11px";
                            //span.style.backgroundColor = input.checked ? span.style.borderColor : 'transparent';
                            if (input.checked) {
                                $(span).addClass('fa').addClass('fa-check');
                            } else {
                                $(span).removeClass('fa').removeClass('fa-check');
                            }
                        }
                    });
                }

                function setDropdownCalendarType() {
                    var calendarTypeName = document.getElementById('calendarTypeName');
                    var calendarTypeIcon = document.getElementById('calendarTypeIcon');
                    var options = cal.getOptions();
                    var type = cal.getViewName();
                    var iconClassName;

                    if (type === 'day') {
                        type = 'Daily';
                        iconClassName = 'calendar-icon ic_view_day';
                    } else if (type === 'week') {
                        type = '周';
                        iconClassName = 'calendar-icon ic_view_week';
                    } else if (options.month.visibleWeeksCount === 2) {
                        type = '2 weeks';
                        iconClassName = 'calendar-icon ic_view_week';
                    } else if (options.month.visibleWeeksCount === 3) {
                        type = '3 weeks';
                        iconClassName = 'calendar-icon ic_view_week';
                    } else {
                        type = '月';
                        iconClassName = 'calendar-icon ic_view_month';
                    }

                    calendarTypeName.innerHTML = type;
                    calendarTypeIcon.className = iconClassName;
                }

                function setRenderRangeText() {
                    var renderRange = document.getElementById('renderRange');
                    var options = cal.getOptions();
                    var viewName = cal.getViewName();
                    var html = [];
                    if (viewName === 'day') {
                        html.push(moment(cal.getDate().getTime()).format('YYYY.MM.DD'));
                    } else if (viewName === 'month' &&
                        (!options.month.visibleWeeksCount || options.month.visibleWeeksCount > 4)) {
                        html.push(moment(cal.getDate().getTime()).format('YYYY.MM'));
                    } else {
                        html.push(moment(cal.getDateRangeStart().getTime()).format('YYYY.MM.DD'));
                        html.push(' ~ ');
                        html.push(moment(cal.getDateRangeEnd().getTime()).format(' MM.DD'));
                    }
                    renderRange.innerHTML = html.join('');
                }

                var refreshAll = function (scheduleDtoList) {
                    ScheduleList = [];
                    //CompanyList = [];

                    scheduleDataSourceList = scheduleDtoList;

                    //提取Compay ID Name 并排重
                    //CompanyList = _.uniq(_.map(scheduleDtoList, function (dt) {
                    //    return {
                    //        value: dt.companyID,
                    //        name: dt.companyName,
                    //        checked: true
                    //    }
                    //}), false, function (sch) { return sch.value });


                    if (scheduleDtoList && scheduleDtoList.length > 0) {
                        $('.lnb-calendars-d1').show();
                        _.each(scheduleDtoList, function (dto) {
                            var schedule = new ScheduleInfo();
                            schedule.id = dto.id;
                            schedule.calendarId = dto.taxProjectID;
                            schedule.title = dto.eventName + (dto.status == "0" ? "-未完成" : "-已完成");
                            schedule.isAllday = true;
                            schedule.start = new Date(dto.start);
                            schedule.end = new Date(dto.end);
                            schedule.category = 'allday';

                            schedule.companyID = dto.companyID;
                            schedule.status = dto.status.toString();
                            schedule.calendarType = (!!dto.operatorNames && (dto.operatorNames.toLowerCase() === loginContext.userName.toLowerCase())).toString();


                            var calendar = _.filter(CalendarList, function (ca) { return ca.id === dto.taxProjectID })[0];

                            schedule.color = calendar.color;
                            schedule.bgColor = calendar.bgColor;
                            schedule.dragBgColor = calendar.dragBgColor;
                            schedule.borderColor = calendar.borderColor;
                            schedule.location = dto.workPlaceName;
                            schedule.recurrenceRule = false;

                            schedule.raw = {
                                fileList: dto.fileList,
                                hasToOrCc: false,
                                hasRecurrenceRule: false,
                                location: dto.workPlaceName,
                                class: 'public', // or 'private'
                                creator: {
                                    name: dto.operatorNames,
                                    company: dto.companyName
                                }
                            }

                            ScheduleList.push(schedule);
                        });
                    } else {
                    }

                    angular.copy(ScheduleList, dataOptions.allScheduleList);

                    renderFilter();
                    refreshSchedule();

                };

                $scope.permissionData = {};
                function setSchedules() {
                    taxCalendarService.getTaxCalendarDataForDisplay(cal.getDateRangeStart(), cal.getDateRangeEnd()).success(function (scheduleDtoList) {
                        //如果登录用户没有查看，则不显示相应的税务日历
                        // userService.getUserPermissionNew(loginContext.userName, function (data) {
                        //     $scope.permissionData = data;
                        //     if (!window.PWC.isHavePermission($scope.vatPermission.taxCalendarDisplay.sysCalendarView, $scope.permissionData)) {
                        //         scheduleDtoList = _.filter(scheduleDtoList, function (r) {
                        //             return r.type != 2;
                        //         })
                        //     }
                        // });
                        // 自定义事件，只能显示自己自定义的
                        scheduleDtoList = _.filter(scheduleDtoList, function (r) {
                            if (r.type === constant.EnumTaxEventType.UserDefine && r.operatorIDs != loginContext.userId) {
                                return false;
                            }

                            return true;
                        });

                        refreshAll(scheduleDtoList);

                    }).error(function (ex) {
                        $log.error(ex);
                        SweetAlert.warning($translate.instant('SystemException'));
                    });
                }



                //根据ScheduleList更新界面显示
                function refreshSchedule() {
                    cal.clear();
                    //generateSchedule(cal.getViewName(), cal.getDateRangeStart(), cal.getDateRangeEnd());
                    cal.createSchedules(ScheduleList);
                    refreshScheduleVisibility();
                };

                function renderFilter() {
                    var calendarList = document.getElementById('calendarList');
                    var html = [];
                    CalendarList.forEach(function (calendar) {
                        html.push('<div class="lnb-calendars-item" style="background: ' + calendar.borderColor + ' ;"><label>' +
                            '<input type="checkbox" class="tui-full-calendar-checkbox-round" value="' + calendar.id + '" checked>' +
                            // '<span style="border-color: ' + calendar.borderColor + '; background-color: ' + calendar.borderColor + ';margin-top:3px;display:inline-block;vertical-align:top;"></span>' +
                            '<span style="margin-top:5px;display:inline-block;vertical-align:top;"></span>' +
                            '<span style="display:inline-block;line-height:20px;width:80%;color:white;">' + calendar.name + '</span>' +
                            '</label></div>'
                        );
                    });
                    calendarList.innerHTML = html.join('\n');

                    renderList(CompanyList, 'companyList','#aaa');
                    renderList(dataOptions.statusList, 'statusList','#aaa');
                    renderList(dataOptions.calendarTypeList, 'calendarTypeList', '#aaa');

                    var viewAll = document.getElementById('viewAll');
                    viewAll.checked = true;
                }

                //选中列表(id,name格式) 显示 
                function renderList(List, elementId,color) {
                    var elementList = document.getElementById(elementId);
                    var html = [];
                    List.forEach(function (item) {
                        html.push('<div class="lnb-calendars-item"><label>' +
                                '<input type="checkbox" class="tui-full-calendar-checkbox-round" eleType=' + elementId + ' value="' + item.value + '" checked>' +
                            '<span class="fa fa-check" style="border-color: ' + color + ';border-size: 1px; margin-top:4px;display:inline-block;vertical-align:top;color:#aaa;line-height:9px;padding-left: 2px;font-size: 11px;"></span>' +
                                '<span style="display:inline-block;line-height:20px;width:80%;">' + item.name + '</span>' +
                                '</label></div>'
                            );
                    });
                    elementList.innerHTML = html.join('\n');
                }


                function setEventListener() {
                    $('#menu-navi').on('click', onClickNavi);
                    $('.dropdown-menu a[role="menuitem"]').on('click', onClickMenu);
                    $('#lnb-calendars').on('change', onChangeCalendars);

                    $('#btn-save-schedule').on('click', onNewSchedule);
                    $('#btn-new-schedule').on('click', createNewSchedule);

                    $('#dropdownMenu-calendars-list').on('click', onChangeNewScheduleCalendar);

                    window.addEventListener('resize', resizeThrottled);
                }

                function getDataAction(target) {
                    return target.dataset ? target.dataset.action : target.getAttribute('data-action');
                }

                var getTaxProjectList = function () {
                    taxProjectList = [];
                   
                    var setColor = function (data) {
                       
                        var colorLenth = dataOptions.colorArray.length;
                        for (var key = 0; key < data.length; key++) {
                            var value = data[key];
                            value.colorGroup = {
                                color: dataOptions.colorArray[key % colorLenth].color,
                                bgColor: dataOptions.colorArray[key % colorLenth].bgColor,
                                dragBgColor: dataOptions.colorArray[key % colorLenth].dragBgColor,
                                borderColor: dataOptions.colorArray[key % colorLenth].borderColor
                            };
                        }

                        taxProjectList = data;
                    };

                    var setCalendar = function () {
                        // 全局变量
                        CalendarList = [];

                        //补全颜色 生成 CalendarList
                        var colorLenth = dataOptions.colorArray.length;

                        taxProjectList.forEach(function (value) {
                            var colorGroup = value.colorGroup;
                            CalendarList.push({
                                id: value.id,
                                name: value.taxProjectName,
                                checked: true,
                                color: colorGroup.color,
                                bgColor: colorGroup.bgColor,
                                dragBgColor: colorGroup.dragBgColor,
                                borderColor: colorGroup.borderColor
                            });

                        });
                    };

                    taxCalendarService.getAllTaxProjectList().success(function (data) {
                        setColor(data);

                        setCalendar();
                        setSchedules();
                    }).error(function (data) {
                        $log.error(data);
                        SweetAlert.warning($translate.instant('SystemException'));
                    });
                };

                resizeThrottled = tui.util.throttle(function () {
                    cal.render();
                }, 50);

                window.cal = cal;
                window.refreshAll = refreshAll;

                window.setSchedules = setSchedules;

                setDropdownCalendarType();
                setRenderRangeText();
                getTaxProjectList();
                 
                setEventListener();
                renderFilter();

            })(window, tui.Calendar);
        };

        //读取API的service
        var getService = {

        };

        //新增数据的service
        var addService = {
            //TO DO
        };

        //更新数据的service
        var updateService = {
            //TO DO
        };

        //删除数据的service
        var deleteService = {
            //TO DO
        };


        //内部数据服务, 仅供该方法内部使用的方法
        var memoryService = {

            //refreshDataGrid:function{},
            //checkIsEmpty:function{},
            //translateEnumValue:function{},
            //....................
        };

        //所有页面按钮的事件放在eventService里面
        $scope.eventService = {

            //btnUpload:function(){},
            //btnRecognizeInvoice:function(){},
            //btnRefreshPage:function(){},
            //........................
        }

        //页面加载初始化控件
        var initControls = function () {
            //initDxDataGrid();
            //initSearchBoxOptions();
            //...............
            initCalendar();
        };

        //页面加载初始化数据
        var initData = function () {

            //loadInvoiceList();
            //loadSearchBasicData();
            //.........
        };

        //权限控制
        var checkPermission = function () {
            return;

            var deferred = $q.defer();

            var result = $rootScope.getInputInvoicePermissionData().then(function (data) {
                if (data) {

                    var codeList = [];
                    var p2pUserCode = constant.inputInvoicePermission.P2PUser.code;
                    codeList.push(verifyCode);
                    $rootScope.checkInputInvoicePermissionList(codeList).success(function (hasPermission) {
                        $scope.permission.isP2P = hasPermission[p2pUserCode];
                        //p2p的时候，发票来源为报销的时候，需要放在p2p，发票的所有的操作都在这儿完成
                        if (!$scope.permission.isP2P) {
                            deferred.resolve(false);
                        }
                        else {
                            deferred.resolve(true);
                        }
                    });
                }
            });


            return deferred.promise;
        };


        $scope.popupOptions = {
            operateType: null,
            operateModel: {},

            onClosed: function (param) {
                console.log(param);
                //$log.debug(param);
                //setSchedules();

                if (param.type && param.type.length > 0) {

                    // 直接重新取数据
                    var data = {
                        id: param.data.id,
                        type: param.data.type,
                        taxProjectID: param.data.taxProjectID,
                        taxProjectName: param.data.taxProjectName,
                        companyID: param.data.companyID,
                        companyName: param.data.companyName,
                        workPlaceID: param.data.workPlaceID,
                        workPlaceName: param.data.workPlaceName,
                        isRelatedTaxMoney: param.data.isRelatedTaxMoney,
                        operatorIDs: param.data.operatorIDs,
                        operatorNames: param.data.operatorNames,
                        notifierIDs: param.data.notifierIDs,
                        notifierNames: param.data.notifierNames,
                        operationDate: param.data.operationDate,
                        remark: param.data.remark,
                        status: param.data.status,
                        postscript: param.data.postscript,
                        createTime: param.data.createTime,
                        updateTime: param.data.updateTime,
                        eventDate: param.data.eventDate,
                        attachRemark: param.data.attachRemark,
                        start: param.data.eventDate,
                        end: param.data.eventDate,
                        eventName: param.data.eventName,
                        calendarNumber: param.data.calendarNumber,
                        completeUserID: param.data.completeUserID,
                        completeUserName:param.data.completeUserName,
                        fileList: param.data.fileList
                    };

             
                    if (param.type === 'addSuccess') {
                        scheduleDataSourceList.push(data);
                    }
                    else if (param.type === 'deleteSuccess') {

                        scheduleDataSourceList = _.filter(scheduleDataSourceList, function (r) {
                            return r.id != data.id
                        });
                    } else if (param.type === 'updateSuccess') {

                        var index = _.findIndex(scheduleDataSourceList, { id: param.data.id });
                        if (index > -1) {
                            scheduleDataSourceList[index] = data;
                        }
                    }

                    try {
                        window.refreshAll(scheduleDataSourceList);
                    } catch (ex) {
                        console.log(ex);
                    }
                }
            }
        };

        var createNewScheduleClick = function (e) {
            //如果有编辑自定义事项的权限才能新建
            // if (!window.PWC.isHavePermission($scope.vatPermission.taxCalendarDisplay.userCalendarEdit, $scope.permissionData)) {
            //     return;
            // }
            var guide = e.guide;
            // use guideEl$'s left, top to locate your schedule creation popup
            var guideEl$ = guide.guideElement ?
                 guide.guideElement : guide.guideElements[Object.keys(guide.guideElements)[0]];

            var guideBound = guideEl$.getBoundingClientRect();

            var userDefine = getUserDefineTaxProject();

            if (!userDefine) {
                SweetAlert.warning($translate.instant('UserDefineNotInTaxProjectName'));
                return;
            };

            $scope.popupOptions.operateModel = {
                operatorNames: loginContext.userName,
                type: 1,
                companyID: '',
                companyName: '',
                operatorIDs: loginContext.userId,
                eventDate: e.start,
                status: 0,
                guideBound: guideBound,
                taxProjectID: userDefine.id,
                taxProjectName: userDefine.taxProjectName,
                colorGroup: userDefine.colorGroup
            };

            $scope.popupOptions.operateType = constant.Operation.Add;

        };

        var showDetailPopUp = function (e) {
            if (e.schedule) {
                // get origianl data

                var model = _.find(scheduleDataSourceList, { id: e.schedule.id });

                var temp = getTaxProject(model.taxProjectID);

                //var guideBound =  e.event.target.getBoundingClientRect();

                if (model) {
                    $scope.popupOptions.operateModel = angular.copy(model);
                    $scope.popupOptions.operateModel._event = e.event;
                    $scope.popupOptions.operateModel.colorGroup = temp;
                    $scope.popupOptions.operateType = constant.Operation.Query;

                    //修改日历设置事项的事项类别
                    var userDefine = getUserDefineTaxProject();
                    if ($scope.popupOptions.operateModel.taxProjectName != userDefine.taxProjectName) {
                        $scope.popupOptions.operateModel.taxProjectName = $translate.instant('CalendarSetEvent');
                    }
                }
            }
        };

        var getUserDefineTaxProject = function () {
            if (!taxProjectList || taxProjectList.length === 0) {
                return null;
            }
            
            return taxProjectList[0];
        };

        var getTaxProject = function (id) {

            if (!taxProjectList || taxProjectList.length === 0) {
                return dataOptions.colorArray[0];
            }

            var tax = _.find(taxProjectList, { id: id });
            if (tax) {
                return tax.colorGroup;
            }

            // 没有找到数据，默认取第一条的colorGroup
            return taxProjectList[0].colorGroup;
        };

        //获取用户的可访问的公司列表
        var getCompanyList = function () {
            CompanyList = []
            taxCalendarService.getTaxCalendarUserCompanys(loginContext.userName).success(function (datas) {
                if (datas && datas.length > 0) {
                    CompanyList = _.map(datas, function (dt) {
                        return {
                            value: dt.id,
                            name: dt.name,
                            checked: true
                        }
                    });
                }
            });
        };

        (function initialize() {
            $log.debug('saleOrderListController.ctor()...');
            $(".tui-full-calendar-timegrid-todaymarker").hide();
            //checkPermission().then(function (hasPermission) {
            //    if (!hasPermission) {
            //        $location.path(loginContext.noPermissionUrl);//403. no permission page
            //    }
            //    else {
            //        initData();
            //    }
            //});

            initScopeVariable();
            initControls();
            getCompanyList();
            //getTaxProjectList();

        })();
    }
]);

