﻿webservices.factory('vatPreviewService', ['$http', 'apiConfig','FileSaver', 'vatSessionService',function ($http, apiConfig,FileSaver,vatSessionService) {
    'use strict';
    return {
        sample: function () {
            return $http.get('url', apiConfig.createVat());
        },

        queryOutputInvoiceAllList: function (param) {
            return $http.post('/outputInvoiceImport/queryOutputInvoiceAllList', {
                // PageInfo: param.pageInfo,
                PeriodStart: param.periodStart,
                PeriodEnd: param.periodEnd,
                InvoiceType: param.invoiceType,
                StartInvoiceDate: param.invoiceDateStart,
                EndInvoiceDate: param.invoiceDateEnd,
                ClassCode: param.classCode,
                InvoiceNumber: param.invoiceNumber,
                BuyerName: param.buyerName,
                ProductName: param.productName,
                AmountStart: param.amountStart,
                AmountEnd: param.amountEnd,
                TaxAmountStart: param.taxAmountStart,
                TaxAmountEnd: param.taxAmountEnd,
                Tag: param.tag,
            }, apiConfig.createVat());
        },

        queryOutputInvoiceList: function (param) {
            return $http.post('/outputInvoiceImport/queryOutputInvoiceList', {
                PageInfo: param.pageInfo,
                PeriodStart: param.periodStart,
                PeriodEnd: param.periodEnd,
                InvoiceType: param.invoiceType,
                StartInvoiceDate: param.invoiceDateStart,
                EndInvoiceDate: param.invoiceDateEnd,
                ClassCode: param.classCode,
                InvoiceNumber: param.invoiceNumber,
                BuyerName: param.buyerName,
                ProductName: param.productName,
                AmountStart: param.amountStart,
                AmountEnd: param.amountEnd,
                TaxAmountStart: param.taxAmountStart,
                TaxAmountEnd: param.taxAmountEnd,
                Tag: param.tag,
            }, apiConfig.createVat());
        },

        queryOutputInvoiceItemList: function (invoiceID,tag) {
            return $http.get('/outputInvoiceImport/queryOutputInvoiceItemList/' + invoiceID+'?tag='+tag, apiConfig.createVat());
        },

        getExportOutputInvoiceList: function (param) {
            return $http.post('/outputInvoiceImport/getExportOutputInvoiceList', {
                PageInfo: param.pageInfo,
                PeriodStart: param.periodStart,
                PeriodEnd: param.periodEnd,
                InvoiceType: param.invoiceType,
                StartInvoiceDate: param.invoiceDateStart,
                EndInvoiceDate: param.invoiceDateEnd,
                ClassCode: param.classCode,
                InvoiceNumber: param.invoiceNumber,
                BuyerName: param.buyerName,
                ProductName: param.productName,
                AmountStart: param.amountStart,
                AmountEnd: param.amountEnd,
                TaxAmountStart: param.taxAmountStart,
                TaxAmountEnd: param.taxAmountEnd,
            }, apiConfig.createVat({ responseType: 'arraybuffer' }));
        },


        queryInputInvoiceList: function (param) {
                return $http.post('/inputInvoiceImport/inputInvoicePreviewList', {
                    PageInfo: param.pageInfo,
                    PeriodStart: param.periodStart,
                    PeriodEnd: param.periodEnd,
                    CertificationDateStart: param.certificationDateStart,
                    CertificationDateEnd: param.certificationDateEnd,
                    InvoiceCode: param.invoiceCode,
                    InvoiceNumber: param.invoiceNumber,
                    SellerTaxNumber: param.sellerTaxNumber,
                    AmountStart: param.amountStart,
                    AmountEnd: param.amountEnd,
                    InvoiceType: param.invoiceType,
                    TaxAmountStart: param.taxAmountStart,
                    TaxAmountEnd: param.taxAmountEnd,
                    CertificationStatus: param.certificationStatus
                }, apiConfig.createVat());
        },

        queryInputInvoiceAllList: function (param) {
                return $http.post('/inputInvoiceImport/inputInvoicePreviewAllList', {
                    // PageInfo: param.pageInfo,
                    PeriodStart: param.periodStart,
                    PeriodEnd: param.periodEnd,
                    CertificationDateStart: param.certificationDateStart,
                    CertificationDateEnd: param.certificationDateEnd,
                    InvoiceCode: param.invoiceCode,
                    InvoiceNumber: param.invoiceNumber,
                    SellerTaxNumber: param.sellerTaxNumber,
                    AmountStart: param.amountStart,
                    AmountEnd: param.amountEnd,
                    InvoiceType: param.invoiceType,
                    TaxAmountStart: param.taxAmountStart,
                    TaxAmountEnd: param.taxAmountEnd,
                    CertificationStatus: param.certificationStatus
                }, apiConfig.createVat());
        },

        queryInputInvoiceItemList: function (inputInvoiceID) {
            return $http.get('/inputInvoiceImport/inputInvoiceItemPreviewList/' + inputInvoiceID, apiConfig.createVat());
        },

        //导出进项发票数据
        getExportInputInvoiceList: function (param) {
            return $http.post('/inputInvoiceImport/exportQueryData/get', {
                PageInfo: param.pageInfo,
                PeriodStart: param.periodStart,
                PeriodEnd: param.periodEnd,
                CertificationDateStart: param.certificationDateStart,
                CertificationDateEnd: param.certificationDateEnd,
                InvoiceCode: param.invoiceCode,
                InvoiceNumber: param.invoiceNumber,
                SellerTaxNumber: param.sellerTaxNumber,
                AmountStart: param.amountStart,
                AmountEnd: param.amountEnd,
                InvoiceType: param.invoiceType,
                TaxAmountStart: param.taxAmountStart,
                TaxAmountEnd: param.taxAmountEnd,
                CertificationStatus: param.certificationStatus
            }, apiConfig.createVat({ responseType: 'arraybuffer' }));
        },
 
        voucherSelectAdvancedByEntry: function (mainRelation, allJe, pagingInfo, listQueryCondition) {
            return $http.post('/voucher/voucherSelectAdvancedByEntry', {
                MainRelation: mainRelation,
                AllJe: allJe,
                PagingInfo: pagingInfo,
                ListQueryCondition: listQueryCondition
            }, apiConfig.create());
        },
        voucherSelectAdvancedByVoucher: function (mainRelation, allJe, pagingInfo, listQueryCondition) {
            return $http.post('/voucher/voucherSelectAdvancedByVoucher', {
                MainRelation: mainRelation,
                AllJe: allJe,
                PagingInfo: pagingInfo,
                ListQueryCondition: listQueryCondition
            }, apiConfig.create());
        },
        voucherSelectAdvancedCount: function (mainRelation, isEntryShow, allJe, listQueryCondition) {
            return $http.post('/voucher/voucherSelectAdvancedCount', {
                MainRelation: mainRelation,
                AllJe: allJe,
                IsEntryShow: isEntryShow,
                ListQueryCondition: listQueryCondition
            }, apiConfig.create());
        },
        getVoucherByConditon: function (mainRelation, allJe, period, vID, group, listQueryCondition) {
            return $http.post('/voucher/getVoucherByConditon', {
                MainRelation: mainRelation,
                AllJe: allJe,
                Period: period,
                VID: vID,
                Group: group,
                ListQueryCondition: listQueryCondition
            }, apiConfig.create());
        },
        getSelectWhereString: function (mainRelation, allJe, listQueryCondition) {
            return $http.post('/voucher/getSelectWhereString', {
                MainRelation: mainRelation,
                AllJe: allJe,
                ListQueryCondition: listQueryCondition
            }, apiConfig.create());
        },
        getEnterpriseAccount: function () {
            return $http.get('/voucher/getEnterpriseAccount', apiConfig.create());
        },



        /****************************************************************************************************/
        /* Tony's Beatup services */
        getTBDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getTBDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportTBData: function (queryParams) {
            return $http.post('/dataPreview/exportTBData/get', queryParams, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        getTBEndPeriodDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getTBEndPeriodDataForDisplay', queryParams, apiConfig.createVat());
        },
        //服务器导出
        initExportTBEndPeriodData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportTBEndPeriodData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getCFDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getCFDataForDisplay', queryParams, apiConfig.createVat());
        },
        getCFManualDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getCFManualDataForDisplay', queryParams, apiConfig.createVat());
        },
        //服务器导出
        initExportCFData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportCFData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'-'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        initExportCFMData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportCFMData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'-'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getADTBDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getADTBDataForDisplay', queryParams, apiConfig.createVat());
        },
        //服务器导出
        initExportATData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportADTBData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getPLDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getPLDataForDisplay', queryParams, apiConfig.createVat());
        },
        getPLStatementDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getPLStatementDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportPLData: function (queryParams) {
            return $http.post('/dataPreview/exportPLData/get', queryParams, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        //利润表prc人工导入
        getPLprcManualDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getPLprcManualDataForDisplay', queryParams, apiConfig.createVat());
        },
        //服务器导出 利润表prc人工
        initExportPLprcManualData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportPLprcManualData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        initExportPLStatementData: function (queryParams) {
            return $http.post('/dataPreview/exportPLStatementData/get', queryParams, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        getJEDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getJEDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportJEData: function (queryParams) {
            return $http.post('/dataPreview/exportJEData/get', queryParams, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        getBSDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getBSDataForDisplay', queryParams, apiConfig.createVat());
        },
        getBalanceSheetDataForDisplay:  function (queryParams) {
            return $http.post('/dataPreview/getBalanceSheetDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportBSData: function (queryParams) {
            return $http.post('/dataPreview/exportBSData/get', queryParams, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        //资产负债表prc人工导入
        getBSprcManualDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getBSprcManualDataForDisplay', queryParams, apiConfig.createVat());
        },
        //服务器导出 资产负债表prc人工
        initExportBSprcManualData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportBSprcManualData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        initExportBalanceSheetData: function (queryParams) {
            return $http.post('/dataPreview/exportBalanceSheetData/get', queryParams, apiConfig.create({ responseType: 'arraybuffer' }));
        },
        getIRDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getIRDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportIRData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportIRData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+vatSessionService.year+(queryParm.periodStart<10?'0'+queryParm.periodStart:queryParm.periodStart)+'-'+vatSessionService.year+(queryParm.periodEnd<10?'0'+queryParm.periodEnd:queryParm.periodEnd)+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getCPRDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getCPRDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportCPRData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportCPRData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'-'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getRLITDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getRLITDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportRLITData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportRLITData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'-'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getCILDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getCILDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportCILData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportCILData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'-'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        },
        getIDDataForDisplay: function (queryParams) {
            return $http.post('/dataPreview/getIDDataForDisplay', queryParams, apiConfig.createVat());
        },
        initExportIDData: function (queryParm, fileName) {
            var thisConfig = apiConfig.create();
            thisConfig.responseType = "arraybuffer";
            return $http.post('/dataPreview/exportIDData/get', queryParm, thisConfig).then(function (response) {
                var data = new Blob([response.data], {type: response.headers('Content-Type')});
                FileSaver.saveAs(data,fileName + '_'+queryParm.periodStart+'-'+queryParm.periodEnd+'_'+vatSessionService.project.name+'.xlsx');
            });
        }
    };
}]);