﻿// registration web service proxy
webservices.factory('taxCalendarService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        test: function () { return $http.get('/taxCalendar/test', apiConfig.create()); },
        getWorkPlaceList: function () {
            return $http.get('/taxCalendar/getWorkPlaceList', apiConfig.create());
        },
        getTaxProjectList: function () {
            return $http.get('/taxCalendar/getTaxProjectList', apiConfig.create());
        },
        getAllTaxProjectList: function () {
            return $http.get('/taxCalendar/getAllTaxProjectList', apiConfig.create());
        },
        getTaxCalendarConfigurationList: function (queryParam) {
            return $http.post('/taxCalendar/getTaxCalendarConfigurationList', queryParam, apiConfig.create());
        },
        getTaxCalendarConfigurationByID: function (configID) {
            return $http.get('/taxCalendar/getTaxCalendarConfigurationByID/' + configID, apiConfig.create());
        },
        saveTaxProject: function (data) {
            return $http.post('/taxCalendar/saveTaxProject', data, apiConfig.create());
        },
        deleteTaxProject: function(taxProjectId){
            return $http.post('/taxCalendar/deleteTaxProject/' + taxProjectId, {}, apiConfig.create());
        },
        saveWorkPlace: function (data) {
            return $http.post('/taxCalendar/saveWorkPlace', data, apiConfig.create());
        },
        deleteWorkPlace: function(workPlaceId){
            return $http.post('/taxCalendar/deleteWorkPlace/' + workPlaceId, {}, apiConfig.create());
        },
        saveTaxCalendarConfig: function (data) {
            return $http.post('/taxCalendar/saveTaxCalendarConfig', data, apiConfig.create());
        },
        getMaxNumber: function () {
            return $http.get('/taxCalendar/getMaxNumber', apiConfig.create());
        },
        getTaxCalendarDataForDisplay: function (startData, endDate) {
            return $http.post('/taxCalendar/getTaxCalendarDataForDisplay', { queryStartTime: (new Date(startData)).dateTimeToString('yyyyMMdd'), queryEndTime: (new Date(endDate)).dateTimeToString('yyyyMMdd'), userID: '', userName: '' }, apiConfig.create());
        },
        getTaxCalendarUserCompanys: function (userName) {
            return $http.get('/taxCalendar/getTaxCalendarUserCompanys/' + userName, apiConfig.create());
        },
        checkUserCompanyPromiss: function (queryDto) {
            return $http.post('/taxCalendar/checkUserCompanyPromiss', queryDto, apiConfig.create());
        }
    };
}]);